/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { GeneratedPdfCommand } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
/**
 * AzureFunctionsAppWebhooksApi - axios parameter creator
 * @export
 */
export const AzureFunctionsAppWebhooksApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Webhook for Pdf generation azure functions app
         * @param {GeneratedPdfCommand} [generatedPdfCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AzurefunctionsappwebhooksPdfgeneratedPost: async (generatedPdfCommand?: GeneratedPdfCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/azurefunctionsappwebhooks/pdfgenerated`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(generatedPdfCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AzureFunctionsAppWebhooksApi - functional programming interface
 * @export
 */
export const AzureFunctionsAppWebhooksApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = AzureFunctionsAppWebhooksApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Webhook for Pdf generation azure functions app
         * @param {GeneratedPdfCommand} [generatedPdfCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AzurefunctionsappwebhooksPdfgeneratedPost(generatedPdfCommand?: GeneratedPdfCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AzurefunctionsappwebhooksPdfgeneratedPost(generatedPdfCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * AzureFunctionsAppWebhooksApi - factory interface
 * @export
 */
export const AzureFunctionsAppWebhooksApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = AzureFunctionsAppWebhooksApiFp(configuration)
    return {
        /**
         * 
         * @summary Webhook for Pdf generation azure functions app
         * @param {GeneratedPdfCommand} [generatedPdfCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AzurefunctionsappwebhooksPdfgeneratedPost(generatedPdfCommand?: GeneratedPdfCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1AzurefunctionsappwebhooksPdfgeneratedPost(generatedPdfCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1AzurefunctionsappwebhooksPdfgeneratedPost operation in AzureFunctionsAppWebhooksApi.
 * @export
 * @interface AzureFunctionsAppWebhooksApiApiV1AzurefunctionsappwebhooksPdfgeneratedPostRequest
 */
export interface AzureFunctionsAppWebhooksApiApiV1AzurefunctionsappwebhooksPdfgeneratedPostRequest {
    /**
     * 
     * @type {GeneratedPdfCommand}
     * @memberof AzureFunctionsAppWebhooksApiApiV1AzurefunctionsappwebhooksPdfgeneratedPost
     */
    readonly generatedPdfCommand?: GeneratedPdfCommand
}

/**
 * AzureFunctionsAppWebhooksApi - object-oriented interface
 * @export
 * @class AzureFunctionsAppWebhooksApi
 * @extends {BaseAPI}
 */
export class AzureFunctionsAppWebhooksApi extends BaseAPI {
    /**
     * 
     * @summary Webhook for Pdf generation azure functions app
     * @param {AzureFunctionsAppWebhooksApiApiV1AzurefunctionsappwebhooksPdfgeneratedPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AzureFunctionsAppWebhooksApi
     */
    public apiV1AzurefunctionsappwebhooksPdfgeneratedPost(requestParameters: AzureFunctionsAppWebhooksApiApiV1AzurefunctionsappwebhooksPdfgeneratedPostRequest = {}, options?: AxiosRequestConfig) {
        return AzureFunctionsAppWebhooksApiFp(this.configuration).apiV1AzurefunctionsappwebhooksPdfgeneratedPost(requestParameters.generatedPdfCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
