/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CHAdminModel } from '../models';
// @ts-ignore
import { CHAdminsModel } from '../models';
// @ts-ignore
import { CreateCHAdminCommand } from '../models';
// @ts-ignore
import { Gender } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateCHAdminCommand } from '../models';
/**
 * CHAdminsApi - axios parameter creator
 * @export
 */
export const CHAdminsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete CHAdmin.
         * @param {string} cHAdminId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChadminsCHAdminIdDelete: async (cHAdminId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'cHAdminId' is not null or undefined
            assertParamExists('apiV1ChadminsCHAdminIdDelete', 'cHAdminId', cHAdminId)
            const localVarPath = `/api/v1/chadmins/{cHAdminId}`
                .replace(`{${"cHAdminId"}}`, encodeURIComponent(String(cHAdminId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get CHAdmin.
         * @param {string} cHAdminId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChadminsCHAdminIdGet: async (cHAdminId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'cHAdminId' is not null or undefined
            assertParamExists('apiV1ChadminsCHAdminIdGet', 'cHAdminId', cHAdminId)
            const localVarPath = `/api/v1/chadmins/{cHAdminId}`
                .replace(`{${"cHAdminId"}}`, encodeURIComponent(String(cHAdminId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update CHAdmin.
         * @param {string} cHAdminId 
         * @param {UpdateCHAdminCommand} [updateCHAdminCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChadminsCHAdminIdPut: async (cHAdminId: string, updateCHAdminCommand?: UpdateCHAdminCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'cHAdminId' is not null or undefined
            assertParamExists('apiV1ChadminsCHAdminIdPut', 'cHAdminId', cHAdminId)
            const localVarPath = `/api/v1/chadmins/{cHAdminId}`
                .replace(`{${"cHAdminId"}}`, encodeURIComponent(String(cHAdminId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateCHAdminCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all CHAdmins.
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChadminsGet: async (id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/chadmins`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (fullname !== undefined) {
                localVarQueryParameter['Fullname'] = fullname;
            }

            if (email !== undefined) {
                localVarQueryParameter['Email'] = email;
            }

            if (gender !== undefined) {
                localVarQueryParameter['Gender'] = gender;
            }

            if (dateOfBirth !== undefined) {
                localVarQueryParameter['DateOfBirth'] = (dateOfBirth as any instanceof Date) ?
                    (dateOfBirth as any).toISOString() :
                    dateOfBirth;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a CHAdmin.
         * @param {CreateCHAdminCommand} [createCHAdminCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChadminsPost: async (createCHAdminCommand?: CreateCHAdminCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/chadmins`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createCHAdminCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CHAdminsApi - functional programming interface
 * @export
 */
export const CHAdminsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CHAdminsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete CHAdmin.
         * @param {string} cHAdminId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChadminsCHAdminIdDelete(cHAdminId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChadminsCHAdminIdDelete(cHAdminId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get CHAdmin.
         * @param {string} cHAdminId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChadminsCHAdminIdGet(cHAdminId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHAdminModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChadminsCHAdminIdGet(cHAdminId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update CHAdmin.
         * @param {string} cHAdminId 
         * @param {UpdateCHAdminCommand} [updateCHAdminCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChadminsCHAdminIdPut(cHAdminId: string, updateCHAdminCommand?: UpdateCHAdminCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHAdminModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChadminsCHAdminIdPut(cHAdminId, updateCHAdminCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all CHAdmins.
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChadminsGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHAdminsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChadminsGet(id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a CHAdmin.
         * @param {CreateCHAdminCommand} [createCHAdminCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChadminsPost(createCHAdminCommand?: CreateCHAdminCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHAdminModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChadminsPost(createCHAdminCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * CHAdminsApi - factory interface
 * @export
 */
export const CHAdminsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CHAdminsApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete CHAdmin.
         * @param {string} cHAdminId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChadminsCHAdminIdDelete(cHAdminId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ChadminsCHAdminIdDelete(cHAdminId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get CHAdmin.
         * @param {string} cHAdminId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChadminsCHAdminIdGet(cHAdminId: string, options?: any): AxiosPromise<CHAdminModel> {
            return localVarFp.apiV1ChadminsCHAdminIdGet(cHAdminId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update CHAdmin.
         * @param {string} cHAdminId 
         * @param {UpdateCHAdminCommand} [updateCHAdminCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChadminsCHAdminIdPut(cHAdminId: string, updateCHAdminCommand?: UpdateCHAdminCommand, options?: any): AxiosPromise<CHAdminModel> {
            return localVarFp.apiV1ChadminsCHAdminIdPut(cHAdminId, updateCHAdminCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all CHAdmins.
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChadminsGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<CHAdminsModel> {
            return localVarFp.apiV1ChadminsGet(id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a CHAdmin.
         * @param {CreateCHAdminCommand} [createCHAdminCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChadminsPost(createCHAdminCommand?: CreateCHAdminCommand, options?: any): AxiosPromise<CHAdminModel> {
            return localVarFp.apiV1ChadminsPost(createCHAdminCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1ChadminsCHAdminIdDelete operation in CHAdminsApi.
 * @export
 * @interface CHAdminsApiApiV1ChadminsCHAdminIdDeleteRequest
 */
export interface CHAdminsApiApiV1ChadminsCHAdminIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof CHAdminsApiApiV1ChadminsCHAdminIdDelete
     */
    readonly cHAdminId: string

    /**
     * 
     * @type {boolean}
     * @memberof CHAdminsApiApiV1ChadminsCHAdminIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1ChadminsCHAdminIdGet operation in CHAdminsApi.
 * @export
 * @interface CHAdminsApiApiV1ChadminsCHAdminIdGetRequest
 */
export interface CHAdminsApiApiV1ChadminsCHAdminIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CHAdminsApiApiV1ChadminsCHAdminIdGet
     */
    readonly cHAdminId: string
}

/**
 * Request parameters for apiV1ChadminsCHAdminIdPut operation in CHAdminsApi.
 * @export
 * @interface CHAdminsApiApiV1ChadminsCHAdminIdPutRequest
 */
export interface CHAdminsApiApiV1ChadminsCHAdminIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof CHAdminsApiApiV1ChadminsCHAdminIdPut
     */
    readonly cHAdminId: string

    /**
     * 
     * @type {UpdateCHAdminCommand}
     * @memberof CHAdminsApiApiV1ChadminsCHAdminIdPut
     */
    readonly updateCHAdminCommand?: UpdateCHAdminCommand
}

/**
 * Request parameters for apiV1ChadminsGet operation in CHAdminsApi.
 * @export
 * @interface CHAdminsApiApiV1ChadminsGetRequest
 */
export interface CHAdminsApiApiV1ChadminsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CHAdminsApiApiV1ChadminsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof CHAdminsApiApiV1ChadminsGet
     */
    readonly fullname?: string

    /**
     * 
     * @type {string}
     * @memberof CHAdminsApiApiV1ChadminsGet
     */
    readonly email?: string

    /**
     * 
     * @type {Gender}
     * @memberof CHAdminsApiApiV1ChadminsGet
     */
    readonly gender?: Gender

    /**
     * 
     * @type {Date}
     * @memberof CHAdminsApiApiV1ChadminsGet
     */
    readonly dateOfBirth?: Date

    /**
     * 
     * @type {Date}
     * @memberof CHAdminsApiApiV1ChadminsGet
     */
    readonly created?: Date

    /**
     * 
     * @type {boolean}
     * @memberof CHAdminsApiApiV1ChadminsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof CHAdminsApiApiV1ChadminsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof CHAdminsApiApiV1ChadminsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof CHAdminsApiApiV1ChadminsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ChadminsPost operation in CHAdminsApi.
 * @export
 * @interface CHAdminsApiApiV1ChadminsPostRequest
 */
export interface CHAdminsApiApiV1ChadminsPostRequest {
    /**
     * 
     * @type {CreateCHAdminCommand}
     * @memberof CHAdminsApiApiV1ChadminsPost
     */
    readonly createCHAdminCommand?: CreateCHAdminCommand
}

/**
 * CHAdminsApi - object-oriented interface
 * @export
 * @class CHAdminsApi
 * @extends {BaseAPI}
 */
export class CHAdminsApi extends BaseAPI {
    /**
     * 
     * @summary Delete CHAdmin.
     * @param {CHAdminsApiApiV1ChadminsCHAdminIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHAdminsApi
     */
    public apiV1ChadminsCHAdminIdDelete(requestParameters: CHAdminsApiApiV1ChadminsCHAdminIdDeleteRequest, options?: AxiosRequestConfig) {
        return CHAdminsApiFp(this.configuration).apiV1ChadminsCHAdminIdDelete(requestParameters.cHAdminId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get CHAdmin.
     * @param {CHAdminsApiApiV1ChadminsCHAdminIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHAdminsApi
     */
    public apiV1ChadminsCHAdminIdGet(requestParameters: CHAdminsApiApiV1ChadminsCHAdminIdGetRequest, options?: AxiosRequestConfig) {
        return CHAdminsApiFp(this.configuration).apiV1ChadminsCHAdminIdGet(requestParameters.cHAdminId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update CHAdmin.
     * @param {CHAdminsApiApiV1ChadminsCHAdminIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHAdminsApi
     */
    public apiV1ChadminsCHAdminIdPut(requestParameters: CHAdminsApiApiV1ChadminsCHAdminIdPutRequest, options?: AxiosRequestConfig) {
        return CHAdminsApiFp(this.configuration).apiV1ChadminsCHAdminIdPut(requestParameters.cHAdminId, requestParameters.updateCHAdminCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all CHAdmins.
     * @param {CHAdminsApiApiV1ChadminsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHAdminsApi
     */
    public apiV1ChadminsGet(requestParameters: CHAdminsApiApiV1ChadminsGetRequest = {}, options?: AxiosRequestConfig) {
        return CHAdminsApiFp(this.configuration).apiV1ChadminsGet(requestParameters.id, requestParameters.fullname, requestParameters.email, requestParameters.gender, requestParameters.dateOfBirth, requestParameters.created, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a CHAdmin.
     * @param {CHAdminsApiApiV1ChadminsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHAdminsApi
     */
    public apiV1ChadminsPost(requestParameters: CHAdminsApiApiV1ChadminsPostRequest = {}, options?: AxiosRequestConfig) {
        return CHAdminsApiFp(this.configuration).apiV1ChadminsPost(requestParameters.createCHAdminCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
