/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { TranslationContentsModel } from '../models';
// @ts-ignore
import { TranslationTargetEntities } from '../models';
// @ts-ignore
import { UpdateContentTextOnlyValueDomains } from '../models';
/**
 * DevSupportsApi - axios parameter creator
 * @export
 */
export const DevSupportsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Apply database migration
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DevsupportsApplydatabasemigrationPost: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/devsupports/applydatabasemigration`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Generate missing favicons for all webapps
         * @param {Array<string>} [webAppIds] 
         * @param {boolean} [dryRun] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DevsupportsGeneratemissingfaviconsPost: async (webAppIds?: Array<string>, dryRun?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/devsupports/generatemissingfavicons`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (webAppIds) {
                localVarQueryParameter['webAppIds'] = webAppIds;
            }

            if (dryRun !== undefined) {
                localVarQueryParameter['dryRun'] = dryRun;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Find missing translated content, translate all found contents
         * @param {TranslationTargetEntities} targetEntity 
         * @param {string} basisLanguageCode 
         * @param {Array<string>} [translateToFields] Set name of fields to translate; All fields try translate if list is null or empty.
         * @param {string} [id] 
         * @param {boolean} [includesAllEntries] Represents whether only to proceed target items that need to be translated. If true, translate also items that have already been translated. (Default: false)
         * @param {boolean} [isDryRun] Default: true
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DevsupportsTranslatePost: async (targetEntity: TranslationTargetEntities, basisLanguageCode: string, translateToFields?: Array<string>, id?: string, includesAllEntries?: boolean, isDryRun?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'targetEntity' is not null or undefined
            assertParamExists('apiV1DevsupportsTranslatePost', 'targetEntity', targetEntity)
            // verify required parameter 'basisLanguageCode' is not null or undefined
            assertParamExists('apiV1DevsupportsTranslatePost', 'basisLanguageCode', basisLanguageCode)
            const localVarPath = `/api/v1/devsupports/translate`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (targetEntity !== undefined) {
                localVarQueryParameter['targetEntity'] = targetEntity;
            }

            if (basisLanguageCode !== undefined) {
                localVarQueryParameter['basisLanguageCode'] = basisLanguageCode;
            }

            if (translateToFields) {
                localVarQueryParameter['translateToFields'] = translateToFields;
            }

            if (id !== undefined) {
                localVarQueryParameter['id'] = id;
            }

            if (includesAllEntries !== undefined) {
                localVarQueryParameter['includesAllEntries'] = includesAllEntries;
            }

            if (isDryRun !== undefined) {
                localVarQueryParameter['isDryRun'] = isDryRun;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update contentTextOnly values
         * @param {Array<UpdateContentTextOnlyValueDomains>} [targetDomains] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DevsupportsUpdatecontenttextonlyvaluesPost: async (targetDomains?: Array<UpdateContentTextOnlyValueDomains>, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/devsupports/updatecontenttextonlyvalues`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (targetDomains) {
                localVarQueryParameter['targetDomains'] = targetDomains;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * DevSupportsApi - functional programming interface
 * @export
 */
export const DevSupportsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = DevSupportsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Apply database migration
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DevsupportsApplydatabasemigrationPost(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DevsupportsApplydatabasemigrationPost(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Generate missing favicons for all webapps
         * @param {Array<string>} [webAppIds] 
         * @param {boolean} [dryRun] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DevsupportsGeneratemissingfaviconsPost(webAppIds?: Array<string>, dryRun?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DevsupportsGeneratemissingfaviconsPost(webAppIds, dryRun, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Find missing translated content, translate all found contents
         * @param {TranslationTargetEntities} targetEntity 
         * @param {string} basisLanguageCode 
         * @param {Array<string>} [translateToFields] Set name of fields to translate; All fields try translate if list is null or empty.
         * @param {string} [id] 
         * @param {boolean} [includesAllEntries] Represents whether only to proceed target items that need to be translated. If true, translate also items that have already been translated. (Default: false)
         * @param {boolean} [isDryRun] Default: true
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DevsupportsTranslatePost(targetEntity: TranslationTargetEntities, basisLanguageCode: string, translateToFields?: Array<string>, id?: string, includesAllEntries?: boolean, isDryRun?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TranslationContentsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DevsupportsTranslatePost(targetEntity, basisLanguageCode, translateToFields, id, includesAllEntries, isDryRun, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update contentTextOnly values
         * @param {Array<UpdateContentTextOnlyValueDomains>} [targetDomains] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DevsupportsUpdatecontenttextonlyvaluesPost(targetDomains?: Array<UpdateContentTextOnlyValueDomains>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DevsupportsUpdatecontenttextonlyvaluesPost(targetDomains, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * DevSupportsApi - factory interface
 * @export
 */
export const DevSupportsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = DevSupportsApiFp(configuration)
    return {
        /**
         * 
         * @summary Apply database migration
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DevsupportsApplydatabasemigrationPost(options?: any): AxiosPromise<string> {
            return localVarFp.apiV1DevsupportsApplydatabasemigrationPost(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Generate missing favicons for all webapps
         * @param {Array<string>} [webAppIds] 
         * @param {boolean} [dryRun] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DevsupportsGeneratemissingfaviconsPost(webAppIds?: Array<string>, dryRun?: boolean, options?: any): AxiosPromise<string> {
            return localVarFp.apiV1DevsupportsGeneratemissingfaviconsPost(webAppIds, dryRun, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Find missing translated content, translate all found contents
         * @param {TranslationTargetEntities} targetEntity 
         * @param {string} basisLanguageCode 
         * @param {Array<string>} [translateToFields] Set name of fields to translate; All fields try translate if list is null or empty.
         * @param {string} [id] 
         * @param {boolean} [includesAllEntries] Represents whether only to proceed target items that need to be translated. If true, translate also items that have already been translated. (Default: false)
         * @param {boolean} [isDryRun] Default: true
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DevsupportsTranslatePost(targetEntity: TranslationTargetEntities, basisLanguageCode: string, translateToFields?: Array<string>, id?: string, includesAllEntries?: boolean, isDryRun?: boolean, options?: any): AxiosPromise<TranslationContentsModel> {
            return localVarFp.apiV1DevsupportsTranslatePost(targetEntity, basisLanguageCode, translateToFields, id, includesAllEntries, isDryRun, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update contentTextOnly values
         * @param {Array<UpdateContentTextOnlyValueDomains>} [targetDomains] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DevsupportsUpdatecontenttextonlyvaluesPost(targetDomains?: Array<UpdateContentTextOnlyValueDomains>, options?: any): AxiosPromise<string> {
            return localVarFp.apiV1DevsupportsUpdatecontenttextonlyvaluesPost(targetDomains, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1DevsupportsGeneratemissingfaviconsPost operation in DevSupportsApi.
 * @export
 * @interface DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPostRequest
 */
export interface DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPostRequest {
    /**
     * 
     * @type {Array<string>}
     * @memberof DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPost
     */
    readonly webAppIds?: Array<string>

    /**
     * 
     * @type {boolean}
     * @memberof DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPost
     */
    readonly dryRun?: boolean
}

/**
 * Request parameters for apiV1DevsupportsTranslatePost operation in DevSupportsApi.
 * @export
 * @interface DevSupportsApiApiV1DevsupportsTranslatePostRequest
 */
export interface DevSupportsApiApiV1DevsupportsTranslatePostRequest {
    /**
     * 
     * @type {TranslationTargetEntities}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly targetEntity: TranslationTargetEntities

    /**
     * 
     * @type {string}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly basisLanguageCode: string

    /**
     * Set name of fields to translate; All fields try translate if list is null or empty.
     * @type {Array<string>}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly translateToFields?: Array<string>

    /**
     * 
     * @type {string}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly id?: string

    /**
     * Represents whether only to proceed target items that need to be translated. If true, translate also items that have already been translated. (Default: false)
     * @type {boolean}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly includesAllEntries?: boolean

    /**
     * Default: true
     * @type {boolean}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly isDryRun?: boolean
}

/**
 * Request parameters for apiV1DevsupportsUpdatecontenttextonlyvaluesPost operation in DevSupportsApi.
 * @export
 * @interface DevSupportsApiApiV1DevsupportsUpdatecontenttextonlyvaluesPostRequest
 */
export interface DevSupportsApiApiV1DevsupportsUpdatecontenttextonlyvaluesPostRequest {
    /**
     * 
     * @type {Array<UpdateContentTextOnlyValueDomains>}
     * @memberof DevSupportsApiApiV1DevsupportsUpdatecontenttextonlyvaluesPost
     */
    readonly targetDomains?: Array<UpdateContentTextOnlyValueDomains>
}

/**
 * DevSupportsApi - object-oriented interface
 * @export
 * @class DevSupportsApi
 * @extends {BaseAPI}
 */
export class DevSupportsApi extends BaseAPI {
    /**
     * 
     * @summary Apply database migration
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DevSupportsApi
     */
    public apiV1DevsupportsApplydatabasemigrationPost(options?: AxiosRequestConfig) {
        return DevSupportsApiFp(this.configuration).apiV1DevsupportsApplydatabasemigrationPost(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Generate missing favicons for all webapps
     * @param {DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DevSupportsApi
     */
    public apiV1DevsupportsGeneratemissingfaviconsPost(requestParameters: DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPostRequest = {}, options?: AxiosRequestConfig) {
        return DevSupportsApiFp(this.configuration).apiV1DevsupportsGeneratemissingfaviconsPost(requestParameters.webAppIds, requestParameters.dryRun, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Find missing translated content, translate all found contents
     * @param {DevSupportsApiApiV1DevsupportsTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DevSupportsApi
     */
    public apiV1DevsupportsTranslatePost(requestParameters: DevSupportsApiApiV1DevsupportsTranslatePostRequest, options?: AxiosRequestConfig) {
        return DevSupportsApiFp(this.configuration).apiV1DevsupportsTranslatePost(requestParameters.targetEntity, requestParameters.basisLanguageCode, requestParameters.translateToFields, requestParameters.id, requestParameters.includesAllEntries, requestParameters.isDryRun, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update contentTextOnly values
     * @param {DevSupportsApiApiV1DevsupportsUpdatecontenttextonlyvaluesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DevSupportsApi
     */
    public apiV1DevsupportsUpdatecontenttextonlyvaluesPost(requestParameters: DevSupportsApiApiV1DevsupportsUpdatecontenttextonlyvaluesPostRequest = {}, options?: AxiosRequestConfig) {
        return DevSupportsApiFp(this.configuration).apiV1DevsupportsUpdatecontenttextonlyvaluesPost(requestParameters.targetDomains, options).then((request) => request(this.axios, this.basePath));
    }
}
