/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateTemplateVersionCommand } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SendTemplateVersionCommand } from '../models';
// @ts-ignore
import { TemplateVersionModel } from '../models';
// @ts-ignore
import { TemplateVersionsModel } from '../models';
// @ts-ignore
import { UpdateTemplateVersionCommand } from '../models';
/**
 * EmailMarketingsApi - axios parameter creator
 * @export
 */
export const EmailMarketingsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all templateVersions.
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsGet: async (page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/emailmarketings/versions`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a templateVersion.
         * @param {CreateTemplateVersionCommand} [createTemplateVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsPost: async (createTemplateVersionCommand?: CreateTemplateVersionCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/emailmarketings/versions`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createTemplateVersionCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete templateVersion.
         * @param {string} versionId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsVersionIdDelete: async (versionId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'versionId' is not null or undefined
            assertParamExists('apiV1EmailmarketingsVersionsVersionIdDelete', 'versionId', versionId)
            const localVarPath = `/api/v1/emailmarketings/versions/{versionId}`
                .replace(`{${"versionId"}}`, encodeURIComponent(String(versionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get templateVersion.
         * @param {string} versionId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsVersionIdGet: async (versionId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'versionId' is not null or undefined
            assertParamExists('apiV1EmailmarketingsVersionsVersionIdGet', 'versionId', versionId)
            const localVarPath = `/api/v1/emailmarketings/versions/{versionId}`
                .replace(`{${"versionId"}}`, encodeURIComponent(String(versionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update templateVersion.
         * @param {string} versionId 
         * @param {UpdateTemplateVersionCommand} [updateTemplateVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsVersionIdPut: async (versionId: string, updateTemplateVersionCommand?: UpdateTemplateVersionCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'versionId' is not null or undefined
            assertParamExists('apiV1EmailmarketingsVersionsVersionIdPut', 'versionId', versionId)
            const localVarPath = `/api/v1/emailmarketings/versions/{versionId}`
                .replace(`{${"versionId"}}`, encodeURIComponent(String(versionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateTemplateVersionCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Send templateVersion email.
         * @param {string} versionId 
         * @param {SendTemplateVersionCommand} [sendTemplateVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsVersionIdSendPost: async (versionId: string, sendTemplateVersionCommand?: SendTemplateVersionCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'versionId' is not null or undefined
            assertParamExists('apiV1EmailmarketingsVersionsVersionIdSendPost', 'versionId', versionId)
            const localVarPath = `/api/v1/emailmarketings/versions/{versionId}/send`
                .replace(`{${"versionId"}}`, encodeURIComponent(String(versionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(sendTemplateVersionCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * EmailMarketingsApi - functional programming interface
 * @export
 */
export const EmailMarketingsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = EmailMarketingsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all templateVersions.
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1EmailmarketingsVersionsGet(page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TemplateVersionsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1EmailmarketingsVersionsGet(page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a templateVersion.
         * @param {CreateTemplateVersionCommand} [createTemplateVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1EmailmarketingsVersionsPost(createTemplateVersionCommand?: CreateTemplateVersionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TemplateVersionModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1EmailmarketingsVersionsPost(createTemplateVersionCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete templateVersion.
         * @param {string} versionId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1EmailmarketingsVersionsVersionIdDelete(versionId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1EmailmarketingsVersionsVersionIdDelete(versionId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get templateVersion.
         * @param {string} versionId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1EmailmarketingsVersionsVersionIdGet(versionId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TemplateVersionModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1EmailmarketingsVersionsVersionIdGet(versionId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update templateVersion.
         * @param {string} versionId 
         * @param {UpdateTemplateVersionCommand} [updateTemplateVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1EmailmarketingsVersionsVersionIdPut(versionId: string, updateTemplateVersionCommand?: UpdateTemplateVersionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TemplateVersionModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1EmailmarketingsVersionsVersionIdPut(versionId, updateTemplateVersionCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Send templateVersion email.
         * @param {string} versionId 
         * @param {SendTemplateVersionCommand} [sendTemplateVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1EmailmarketingsVersionsVersionIdSendPost(versionId: string, sendTemplateVersionCommand?: SendTemplateVersionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1EmailmarketingsVersionsVersionIdSendPost(versionId, sendTemplateVersionCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * EmailMarketingsApi - factory interface
 * @export
 */
export const EmailMarketingsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = EmailMarketingsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all templateVersions.
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsGet(page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<TemplateVersionsModel> {
            return localVarFp.apiV1EmailmarketingsVersionsGet(page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a templateVersion.
         * @param {CreateTemplateVersionCommand} [createTemplateVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsPost(createTemplateVersionCommand?: CreateTemplateVersionCommand, options?: any): AxiosPromise<TemplateVersionModel> {
            return localVarFp.apiV1EmailmarketingsVersionsPost(createTemplateVersionCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete templateVersion.
         * @param {string} versionId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsVersionIdDelete(versionId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1EmailmarketingsVersionsVersionIdDelete(versionId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get templateVersion.
         * @param {string} versionId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsVersionIdGet(versionId: string, options?: any): AxiosPromise<TemplateVersionModel> {
            return localVarFp.apiV1EmailmarketingsVersionsVersionIdGet(versionId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update templateVersion.
         * @param {string} versionId 
         * @param {UpdateTemplateVersionCommand} [updateTemplateVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsVersionIdPut(versionId: string, updateTemplateVersionCommand?: UpdateTemplateVersionCommand, options?: any): AxiosPromise<TemplateVersionModel> {
            return localVarFp.apiV1EmailmarketingsVersionsVersionIdPut(versionId, updateTemplateVersionCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Send templateVersion email.
         * @param {string} versionId 
         * @param {SendTemplateVersionCommand} [sendTemplateVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailmarketingsVersionsVersionIdSendPost(versionId: string, sendTemplateVersionCommand?: SendTemplateVersionCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1EmailmarketingsVersionsVersionIdSendPost(versionId, sendTemplateVersionCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1EmailmarketingsVersionsGet operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsGetRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsGetRequest {
    /**
     * 
     * @type {number}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1EmailmarketingsVersionsPost operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsPostRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsPostRequest {
    /**
     * 
     * @type {CreateTemplateVersionCommand}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsPost
     */
    readonly createTemplateVersionCommand?: CreateTemplateVersionCommand
}

/**
 * Request parameters for apiV1EmailmarketingsVersionsVersionIdDelete operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdDeleteRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdDelete
     */
    readonly versionId: string
}

/**
 * Request parameters for apiV1EmailmarketingsVersionsVersionIdGet operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdGetRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdGet
     */
    readonly versionId: string
}

/**
 * Request parameters for apiV1EmailmarketingsVersionsVersionIdPut operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPutRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPut
     */
    readonly versionId: string

    /**
     * 
     * @type {UpdateTemplateVersionCommand}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPut
     */
    readonly updateTemplateVersionCommand?: UpdateTemplateVersionCommand
}

/**
 * Request parameters for apiV1EmailmarketingsVersionsVersionIdSendPost operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPostRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPostRequest {
    /**
     * 
     * @type {string}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPost
     */
    readonly versionId: string

    /**
     * 
     * @type {SendTemplateVersionCommand}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPost
     */
    readonly sendTemplateVersionCommand?: SendTemplateVersionCommand
}

/**
 * EmailMarketingsApi - object-oriented interface
 * @export
 * @class EmailMarketingsApi
 * @extends {BaseAPI}
 */
export class EmailMarketingsApi extends BaseAPI {
    /**
     * 
     * @summary Get all templateVersions.
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    public apiV1EmailmarketingsVersionsGet(requestParameters: EmailMarketingsApiApiV1EmailmarketingsVersionsGetRequest = {}, options?: AxiosRequestConfig) {
        return EmailMarketingsApiFp(this.configuration).apiV1EmailmarketingsVersionsGet(requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a templateVersion.
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    public apiV1EmailmarketingsVersionsPost(requestParameters: EmailMarketingsApiApiV1EmailmarketingsVersionsPostRequest = {}, options?: AxiosRequestConfig) {
        return EmailMarketingsApiFp(this.configuration).apiV1EmailmarketingsVersionsPost(requestParameters.createTemplateVersionCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete templateVersion.
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    public apiV1EmailmarketingsVersionsVersionIdDelete(requestParameters: EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdDeleteRequest, options?: AxiosRequestConfig) {
        return EmailMarketingsApiFp(this.configuration).apiV1EmailmarketingsVersionsVersionIdDelete(requestParameters.versionId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get templateVersion.
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    public apiV1EmailmarketingsVersionsVersionIdGet(requestParameters: EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdGetRequest, options?: AxiosRequestConfig) {
        return EmailMarketingsApiFp(this.configuration).apiV1EmailmarketingsVersionsVersionIdGet(requestParameters.versionId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update templateVersion.
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    public apiV1EmailmarketingsVersionsVersionIdPut(requestParameters: EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPutRequest, options?: AxiosRequestConfig) {
        return EmailMarketingsApiFp(this.configuration).apiV1EmailmarketingsVersionsVersionIdPut(requestParameters.versionId, requestParameters.updateTemplateVersionCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Send templateVersion email.
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    public apiV1EmailmarketingsVersionsVersionIdSendPost(requestParameters: EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPostRequest, options?: AxiosRequestConfig) {
        return EmailMarketingsApiFp(this.configuration).apiV1EmailmarketingsVersionsVersionIdSendPost(requestParameters.versionId, requestParameters.sendTemplateVersionCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
