/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateLanguageCommand } from '../models';
// @ts-ignore
import { LanguageModel } from '../models';
// @ts-ignore
import { LanguagesModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateLanguageCommand } from '../models';
/**
 * LanguagesApi - axios parameter creator
 * @export
 */
export const LanguagesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary 
         * @param {string} code 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1LanguagesCodeDelete: async (code: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'code' is not null or undefined
            assertParamExists('apiV1LanguagesCodeDelete', 'code', code)
            const localVarPath = `/api/v1/languages/{code}`
                .replace(`{${"code"}}`, encodeURIComponent(String(code)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Language.
         * @param {string} code 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1LanguagesCodeGet: async (code: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'code' is not null or undefined
            assertParamExists('apiV1LanguagesCodeGet', 'code', code)
            const localVarPath = `/api/v1/languages/{code}`
                .replace(`{${"code"}}`, encodeURIComponent(String(code)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary 
         * @param {string} code 
         * @param {UpdateLanguageCommand} [updateLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1LanguagesCodePut: async (code: string, updateLanguageCommand?: UpdateLanguageCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'code' is not null or undefined
            assertParamExists('apiV1LanguagesCodePut', 'code', code)
            const localVarPath = `/api/v1/languages/{code}`
                .replace(`{${"code"}}`, encodeURIComponent(String(code)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateLanguageCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all Languages.
         * @param {string} [code] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1LanguagesGet: async (code?: string, name?: string, description?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/languages`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (code !== undefined) {
                localVarQueryParameter['Code'] = code;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (description !== undefined) {
                localVarQueryParameter['Description'] = description;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary 
         * @param {CreateLanguageCommand} [createLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1LanguagesPost: async (createLanguageCommand?: CreateLanguageCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/languages`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createLanguageCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * LanguagesApi - functional programming interface
 * @export
 */
export const LanguagesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = LanguagesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary 
         * @param {string} code 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1LanguagesCodeDelete(code: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1LanguagesCodeDelete(code, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Language.
         * @param {string} code 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1LanguagesCodeGet(code: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<LanguageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1LanguagesCodeGet(code, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary 
         * @param {string} code 
         * @param {UpdateLanguageCommand} [updateLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1LanguagesCodePut(code: string, updateLanguageCommand?: UpdateLanguageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<LanguageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1LanguagesCodePut(code, updateLanguageCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all Languages.
         * @param {string} [code] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1LanguagesGet(code?: string, name?: string, description?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<LanguagesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1LanguagesGet(code, name, description, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary 
         * @param {CreateLanguageCommand} [createLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1LanguagesPost(createLanguageCommand?: CreateLanguageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<LanguageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1LanguagesPost(createLanguageCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * LanguagesApi - factory interface
 * @export
 */
export const LanguagesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = LanguagesApiFp(configuration)
    return {
        /**
         * 
         * @summary 
         * @param {string} code 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1LanguagesCodeDelete(code: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1LanguagesCodeDelete(code, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Language.
         * @param {string} code 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1LanguagesCodeGet(code: string, options?: any): AxiosPromise<LanguageModel> {
            return localVarFp.apiV1LanguagesCodeGet(code, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary 
         * @param {string} code 
         * @param {UpdateLanguageCommand} [updateLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1LanguagesCodePut(code: string, updateLanguageCommand?: UpdateLanguageCommand, options?: any): AxiosPromise<LanguageModel> {
            return localVarFp.apiV1LanguagesCodePut(code, updateLanguageCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all Languages.
         * @param {string} [code] 
         * @param {string} [name] 
         * @param {string} [description] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1LanguagesGet(code?: string, name?: string, description?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<LanguagesModel> {
            return localVarFp.apiV1LanguagesGet(code, name, description, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary 
         * @param {CreateLanguageCommand} [createLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1LanguagesPost(createLanguageCommand?: CreateLanguageCommand, options?: any): AxiosPromise<LanguageModel> {
            return localVarFp.apiV1LanguagesPost(createLanguageCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1LanguagesCodeDelete operation in LanguagesApi.
 * @export
 * @interface LanguagesApiApiV1LanguagesCodeDeleteRequest
 */
export interface LanguagesApiApiV1LanguagesCodeDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesCodeDelete
     */
    readonly code: string
}

/**
 * Request parameters for apiV1LanguagesCodeGet operation in LanguagesApi.
 * @export
 * @interface LanguagesApiApiV1LanguagesCodeGetRequest
 */
export interface LanguagesApiApiV1LanguagesCodeGetRequest {
    /**
     * 
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesCodeGet
     */
    readonly code: string
}

/**
 * Request parameters for apiV1LanguagesCodePut operation in LanguagesApi.
 * @export
 * @interface LanguagesApiApiV1LanguagesCodePutRequest
 */
export interface LanguagesApiApiV1LanguagesCodePutRequest {
    /**
     * 
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesCodePut
     */
    readonly code: string

    /**
     * 
     * @type {UpdateLanguageCommand}
     * @memberof LanguagesApiApiV1LanguagesCodePut
     */
    readonly updateLanguageCommand?: UpdateLanguageCommand
}

/**
 * Request parameters for apiV1LanguagesGet operation in LanguagesApi.
 * @export
 * @interface LanguagesApiApiV1LanguagesGetRequest
 */
export interface LanguagesApiApiV1LanguagesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly code?: string

    /**
     * 
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly description?: string

    /**
     * 
     * @type {boolean}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1LanguagesPost operation in LanguagesApi.
 * @export
 * @interface LanguagesApiApiV1LanguagesPostRequest
 */
export interface LanguagesApiApiV1LanguagesPostRequest {
    /**
     * 
     * @type {CreateLanguageCommand}
     * @memberof LanguagesApiApiV1LanguagesPost
     */
    readonly createLanguageCommand?: CreateLanguageCommand
}

/**
 * LanguagesApi - object-oriented interface
 * @export
 * @class LanguagesApi
 * @extends {BaseAPI}
 */
export class LanguagesApi extends BaseAPI {
    /**
     * 
     * @summary 
     * @param {LanguagesApiApiV1LanguagesCodeDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguagesApi
     */
    public apiV1LanguagesCodeDelete(requestParameters: LanguagesApiApiV1LanguagesCodeDeleteRequest, options?: AxiosRequestConfig) {
        return LanguagesApiFp(this.configuration).apiV1LanguagesCodeDelete(requestParameters.code, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Language.
     * @param {LanguagesApiApiV1LanguagesCodeGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguagesApi
     */
    public apiV1LanguagesCodeGet(requestParameters: LanguagesApiApiV1LanguagesCodeGetRequest, options?: AxiosRequestConfig) {
        return LanguagesApiFp(this.configuration).apiV1LanguagesCodeGet(requestParameters.code, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary 
     * @param {LanguagesApiApiV1LanguagesCodePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguagesApi
     */
    public apiV1LanguagesCodePut(requestParameters: LanguagesApiApiV1LanguagesCodePutRequest, options?: AxiosRequestConfig) {
        return LanguagesApiFp(this.configuration).apiV1LanguagesCodePut(requestParameters.code, requestParameters.updateLanguageCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all Languages.
     * @param {LanguagesApiApiV1LanguagesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguagesApi
     */
    public apiV1LanguagesGet(requestParameters: LanguagesApiApiV1LanguagesGetRequest = {}, options?: AxiosRequestConfig) {
        return LanguagesApiFp(this.configuration).apiV1LanguagesGet(requestParameters.code, requestParameters.name, requestParameters.description, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary 
     * @param {LanguagesApiApiV1LanguagesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguagesApi
     */
    public apiV1LanguagesPost(requestParameters: LanguagesApiApiV1LanguagesPostRequest = {}, options?: AxiosRequestConfig) {
        return LanguagesApiFp(this.configuration).apiV1LanguagesPost(requestParameters.createLanguageCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
