/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { MessageWebhookModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { RegisterMessageWebhookCommand } from '../models';
// @ts-ignore
import { UpdateMessageWebhookCommand } from '../models';
/**
 * MessageWebhooksApi - axios parameter creator
 * @export
 */
export const MessageWebhooksApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get list of message webhooks related to the hospital
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MessagewebhooksHospitalIdGet: async (hospitalId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1MessagewebhooksHospitalIdGet', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/messagewebhooks/{hospitalId}`
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get list of message webhooks related to the hospital
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MessagewebhooksHospitalIdWhatsappGet: async (hospitalId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1MessagewebhooksHospitalIdWhatsappGet', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/messagewebhooks/{hospitalId}/whatsapp`
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create message webhook on CH-Message-Broker
         * @param {RegisterMessageWebhookCommand} [registerMessageWebhookCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MessagewebhooksPost: async (registerMessageWebhookCommand?: RegisterMessageWebhookCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/messagewebhooks`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(registerMessageWebhookCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete message webhook by webhookId
         * @param {string} webhookId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MessagewebhooksWebhookIdDelete: async (webhookId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'webhookId' is not null or undefined
            assertParamExists('apiV1MessagewebhooksWebhookIdDelete', 'webhookId', webhookId)
            const localVarPath = `/api/v1/messagewebhooks/{webhookId}`
                .replace(`{${"webhookId"}}`, encodeURIComponent(String(webhookId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update message webhook by webhookId
         * @param {string} webhookId 
         * @param {UpdateMessageWebhookCommand} [updateMessageWebhookCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MessagewebhooksWebhookIdPut: async (webhookId: string, updateMessageWebhookCommand?: UpdateMessageWebhookCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'webhookId' is not null or undefined
            assertParamExists('apiV1MessagewebhooksWebhookIdPut', 'webhookId', webhookId)
            const localVarPath = `/api/v1/messagewebhooks/{webhookId}`
                .replace(`{${"webhookId"}}`, encodeURIComponent(String(webhookId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateMessageWebhookCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * MessageWebhooksApi - functional programming interface
 * @export
 */
export const MessageWebhooksApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = MessageWebhooksApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get list of message webhooks related to the hospital
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1MessagewebhooksHospitalIdGet(hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<MessageWebhookModel>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1MessagewebhooksHospitalIdGet(hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get list of message webhooks related to the hospital
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1MessagewebhooksHospitalIdWhatsappGet(hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MessageWebhookModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1MessagewebhooksHospitalIdWhatsappGet(hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create message webhook on CH-Message-Broker
         * @param {RegisterMessageWebhookCommand} [registerMessageWebhookCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1MessagewebhooksPost(registerMessageWebhookCommand?: RegisterMessageWebhookCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MessageWebhookModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1MessagewebhooksPost(registerMessageWebhookCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete message webhook by webhookId
         * @param {string} webhookId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1MessagewebhooksWebhookIdDelete(webhookId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1MessagewebhooksWebhookIdDelete(webhookId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update message webhook by webhookId
         * @param {string} webhookId 
         * @param {UpdateMessageWebhookCommand} [updateMessageWebhookCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1MessagewebhooksWebhookIdPut(webhookId: string, updateMessageWebhookCommand?: UpdateMessageWebhookCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MessageWebhookModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1MessagewebhooksWebhookIdPut(webhookId, updateMessageWebhookCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * MessageWebhooksApi - factory interface
 * @export
 */
export const MessageWebhooksApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = MessageWebhooksApiFp(configuration)
    return {
        /**
         * 
         * @summary Get list of message webhooks related to the hospital
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MessagewebhooksHospitalIdGet(hospitalId: string, options?: any): AxiosPromise<Array<MessageWebhookModel>> {
            return localVarFp.apiV1MessagewebhooksHospitalIdGet(hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get list of message webhooks related to the hospital
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MessagewebhooksHospitalIdWhatsappGet(hospitalId: string, options?: any): AxiosPromise<MessageWebhookModel> {
            return localVarFp.apiV1MessagewebhooksHospitalIdWhatsappGet(hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create message webhook on CH-Message-Broker
         * @param {RegisterMessageWebhookCommand} [registerMessageWebhookCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MessagewebhooksPost(registerMessageWebhookCommand?: RegisterMessageWebhookCommand, options?: any): AxiosPromise<MessageWebhookModel> {
            return localVarFp.apiV1MessagewebhooksPost(registerMessageWebhookCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete message webhook by webhookId
         * @param {string} webhookId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MessagewebhooksWebhookIdDelete(webhookId: string, options?: any): AxiosPromise<string> {
            return localVarFp.apiV1MessagewebhooksWebhookIdDelete(webhookId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update message webhook by webhookId
         * @param {string} webhookId 
         * @param {UpdateMessageWebhookCommand} [updateMessageWebhookCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1MessagewebhooksWebhookIdPut(webhookId: string, updateMessageWebhookCommand?: UpdateMessageWebhookCommand, options?: any): AxiosPromise<MessageWebhookModel> {
            return localVarFp.apiV1MessagewebhooksWebhookIdPut(webhookId, updateMessageWebhookCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1MessagewebhooksHospitalIdGet operation in MessageWebhooksApi.
 * @export
 * @interface MessageWebhooksApiApiV1MessagewebhooksHospitalIdGetRequest
 */
export interface MessageWebhooksApiApiV1MessagewebhooksHospitalIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksHospitalIdGet
     */
    readonly hospitalId: string
}

/**
 * Request parameters for apiV1MessagewebhooksHospitalIdWhatsappGet operation in MessageWebhooksApi.
 * @export
 * @interface MessageWebhooksApiApiV1MessagewebhooksHospitalIdWhatsappGetRequest
 */
export interface MessageWebhooksApiApiV1MessagewebhooksHospitalIdWhatsappGetRequest {
    /**
     * 
     * @type {string}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksHospitalIdWhatsappGet
     */
    readonly hospitalId: string
}

/**
 * Request parameters for apiV1MessagewebhooksPost operation in MessageWebhooksApi.
 * @export
 * @interface MessageWebhooksApiApiV1MessagewebhooksPostRequest
 */
export interface MessageWebhooksApiApiV1MessagewebhooksPostRequest {
    /**
     * 
     * @type {RegisterMessageWebhookCommand}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksPost
     */
    readonly registerMessageWebhookCommand?: RegisterMessageWebhookCommand
}

/**
 * Request parameters for apiV1MessagewebhooksWebhookIdDelete operation in MessageWebhooksApi.
 * @export
 * @interface MessageWebhooksApiApiV1MessagewebhooksWebhookIdDeleteRequest
 */
export interface MessageWebhooksApiApiV1MessagewebhooksWebhookIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksWebhookIdDelete
     */
    readonly webhookId: string
}

/**
 * Request parameters for apiV1MessagewebhooksWebhookIdPut operation in MessageWebhooksApi.
 * @export
 * @interface MessageWebhooksApiApiV1MessagewebhooksWebhookIdPutRequest
 */
export interface MessageWebhooksApiApiV1MessagewebhooksWebhookIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksWebhookIdPut
     */
    readonly webhookId: string

    /**
     * 
     * @type {UpdateMessageWebhookCommand}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksWebhookIdPut
     */
    readonly updateMessageWebhookCommand?: UpdateMessageWebhookCommand
}

/**
 * MessageWebhooksApi - object-oriented interface
 * @export
 * @class MessageWebhooksApi
 * @extends {BaseAPI}
 */
export class MessageWebhooksApi extends BaseAPI {
    /**
     * 
     * @summary Get list of message webhooks related to the hospital
     * @param {MessageWebhooksApiApiV1MessagewebhooksHospitalIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MessageWebhooksApi
     */
    public apiV1MessagewebhooksHospitalIdGet(requestParameters: MessageWebhooksApiApiV1MessagewebhooksHospitalIdGetRequest, options?: AxiosRequestConfig) {
        return MessageWebhooksApiFp(this.configuration).apiV1MessagewebhooksHospitalIdGet(requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get list of message webhooks related to the hospital
     * @param {MessageWebhooksApiApiV1MessagewebhooksHospitalIdWhatsappGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MessageWebhooksApi
     */
    public apiV1MessagewebhooksHospitalIdWhatsappGet(requestParameters: MessageWebhooksApiApiV1MessagewebhooksHospitalIdWhatsappGetRequest, options?: AxiosRequestConfig) {
        return MessageWebhooksApiFp(this.configuration).apiV1MessagewebhooksHospitalIdWhatsappGet(requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create message webhook on CH-Message-Broker
     * @param {MessageWebhooksApiApiV1MessagewebhooksPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MessageWebhooksApi
     */
    public apiV1MessagewebhooksPost(requestParameters: MessageWebhooksApiApiV1MessagewebhooksPostRequest = {}, options?: AxiosRequestConfig) {
        return MessageWebhooksApiFp(this.configuration).apiV1MessagewebhooksPost(requestParameters.registerMessageWebhookCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete message webhook by webhookId
     * @param {MessageWebhooksApiApiV1MessagewebhooksWebhookIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MessageWebhooksApi
     */
    public apiV1MessagewebhooksWebhookIdDelete(requestParameters: MessageWebhooksApiApiV1MessagewebhooksWebhookIdDeleteRequest, options?: AxiosRequestConfig) {
        return MessageWebhooksApiFp(this.configuration).apiV1MessagewebhooksWebhookIdDelete(requestParameters.webhookId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update message webhook by webhookId
     * @param {MessageWebhooksApiApiV1MessagewebhooksWebhookIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MessageWebhooksApi
     */
    public apiV1MessagewebhooksWebhookIdPut(requestParameters: MessageWebhooksApiApiV1MessagewebhooksWebhookIdPutRequest, options?: AxiosRequestConfig) {
        return MessageWebhooksApiFp(this.configuration).apiV1MessagewebhooksWebhookIdPut(requestParameters.webhookId, requestParameters.updateMessageWebhookCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
