/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { SaveSearchCurationsCommand } from '../models';
// @ts-ignore
import { SearchCurationItemModel } from '../models';
/**
 * SearchCurationsApi - axios parameter creator
 * @export
 */
export const SearchCurationsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all SearchCurationItems
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsLanguageCodeGet: async (languageCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1SearchcurationsLanguageCodeGet', 'languageCode', languageCode)
            const localVarPath = `/api/v1/searchcurations/{languageCode}`
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete SearchCurationItem
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsLanguageCodeIdDelete: async (languageCode: string, id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1SearchcurationsLanguageCodeIdDelete', 'languageCode', languageCode)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('apiV1SearchcurationsLanguageCodeIdDelete', 'id', id)
            const localVarPath = `/api/v1/searchcurations/{languageCode}/{id}`
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get SearchCurationItem by id
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsLanguageCodeIdGet: async (languageCode: string, id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1SearchcurationsLanguageCodeIdGet', 'languageCode', languageCode)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('apiV1SearchcurationsLanguageCodeIdGet', 'id', id)
            const localVarPath = `/api/v1/searchcurations/{languageCode}/{id}`
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get SearchCurationItems by parent id
         * @param {string} languageCode 
         * @param {string} parentId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsLanguageCodeParentIdSubitemsGet: async (languageCode: string, parentId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1SearchcurationsLanguageCodeParentIdSubitemsGet', 'languageCode', languageCode)
            // verify required parameter 'parentId' is not null or undefined
            assertParamExists('apiV1SearchcurationsLanguageCodeParentIdSubitemsGet', 'parentId', parentId)
            const localVarPath = `/api/v1/searchcurations/{languageCode}/{parentId}/subitems`
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)))
                .replace(`{${"parentId"}}`, encodeURIComponent(String(parentId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Save SearchCurationItem
         * @param {string} languageCode 
         * @param {SaveSearchCurationsCommand} [saveSearchCurationsCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsLanguageCodePost: async (languageCode: string, saveSearchCurationsCommand?: SaveSearchCurationsCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1SearchcurationsLanguageCodePost', 'languageCode', languageCode)
            const localVarPath = `/api/v1/searchcurations/{languageCode}`
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(saveSearchCurationsCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revalidate searchCurationItem
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsSlugRevalidatePost: async (slug: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'slug' is not null or undefined
            assertParamExists('apiV1SearchcurationsSlugRevalidatePost', 'slug', slug)
            const localVarPath = `/api/v1/searchcurations/{slug}/revalidate`
                .replace(`{${"slug"}}`, encodeURIComponent(String(slug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SearchCurationsApi - functional programming interface
 * @export
 */
export const SearchCurationsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SearchCurationsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all SearchCurationItems
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SearchcurationsLanguageCodeGet(languageCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<SearchCurationItemModel>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SearchcurationsLanguageCodeGet(languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete SearchCurationItem
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SearchcurationsLanguageCodeIdDelete(languageCode: string, id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SearchcurationsLanguageCodeIdDelete(languageCode, id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get SearchCurationItem by id
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SearchcurationsLanguageCodeIdGet(languageCode: string, id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SearchCurationItemModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SearchcurationsLanguageCodeIdGet(languageCode, id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get SearchCurationItems by parent id
         * @param {string} languageCode 
         * @param {string} parentId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SearchcurationsLanguageCodeParentIdSubitemsGet(languageCode: string, parentId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<SearchCurationItemModel>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SearchcurationsLanguageCodeParentIdSubitemsGet(languageCode, parentId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Save SearchCurationItem
         * @param {string} languageCode 
         * @param {SaveSearchCurationsCommand} [saveSearchCurationsCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SearchcurationsLanguageCodePost(languageCode: string, saveSearchCurationsCommand?: SaveSearchCurationsCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SearchCurationItemModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SearchcurationsLanguageCodePost(languageCode, saveSearchCurationsCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revalidate searchCurationItem
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SearchcurationsSlugRevalidatePost(slug: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SearchcurationsSlugRevalidatePost(slug, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SearchCurationsApi - factory interface
 * @export
 */
export const SearchCurationsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SearchCurationsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all SearchCurationItems
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsLanguageCodeGet(languageCode: string, options?: any): AxiosPromise<Array<SearchCurationItemModel>> {
            return localVarFp.apiV1SearchcurationsLanguageCodeGet(languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete SearchCurationItem
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsLanguageCodeIdDelete(languageCode: string, id: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SearchcurationsLanguageCodeIdDelete(languageCode, id, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get SearchCurationItem by id
         * @param {string} languageCode 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsLanguageCodeIdGet(languageCode: string, id: string, options?: any): AxiosPromise<SearchCurationItemModel> {
            return localVarFp.apiV1SearchcurationsLanguageCodeIdGet(languageCode, id, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get SearchCurationItems by parent id
         * @param {string} languageCode 
         * @param {string} parentId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsLanguageCodeParentIdSubitemsGet(languageCode: string, parentId: string, options?: any): AxiosPromise<Array<SearchCurationItemModel>> {
            return localVarFp.apiV1SearchcurationsLanguageCodeParentIdSubitemsGet(languageCode, parentId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Save SearchCurationItem
         * @param {string} languageCode 
         * @param {SaveSearchCurationsCommand} [saveSearchCurationsCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsLanguageCodePost(languageCode: string, saveSearchCurationsCommand?: SaveSearchCurationsCommand, options?: any): AxiosPromise<SearchCurationItemModel> {
            return localVarFp.apiV1SearchcurationsLanguageCodePost(languageCode, saveSearchCurationsCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revalidate searchCurationItem
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SearchcurationsSlugRevalidatePost(slug: string, languageCode?: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SearchcurationsSlugRevalidatePost(slug, languageCode, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1SearchcurationsLanguageCodeGet operation in SearchCurationsApi.
 * @export
 * @interface SearchCurationsApiApiV1SearchcurationsLanguageCodeGetRequest
 */
export interface SearchCurationsApiApiV1SearchcurationsLanguageCodeGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SearchCurationsApiApiV1SearchcurationsLanguageCodeGet
     */
    readonly languageCode: string
}

/**
 * Request parameters for apiV1SearchcurationsLanguageCodeIdDelete operation in SearchCurationsApi.
 * @export
 * @interface SearchCurationsApiApiV1SearchcurationsLanguageCodeIdDeleteRequest
 */
export interface SearchCurationsApiApiV1SearchcurationsLanguageCodeIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof SearchCurationsApiApiV1SearchcurationsLanguageCodeIdDelete
     */
    readonly languageCode: string

    /**
     * 
     * @type {string}
     * @memberof SearchCurationsApiApiV1SearchcurationsLanguageCodeIdDelete
     */
    readonly id: string
}

/**
 * Request parameters for apiV1SearchcurationsLanguageCodeIdGet operation in SearchCurationsApi.
 * @export
 * @interface SearchCurationsApiApiV1SearchcurationsLanguageCodeIdGetRequest
 */
export interface SearchCurationsApiApiV1SearchcurationsLanguageCodeIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SearchCurationsApiApiV1SearchcurationsLanguageCodeIdGet
     */
    readonly languageCode: string

    /**
     * 
     * @type {string}
     * @memberof SearchCurationsApiApiV1SearchcurationsLanguageCodeIdGet
     */
    readonly id: string
}

/**
 * Request parameters for apiV1SearchcurationsLanguageCodeParentIdSubitemsGet operation in SearchCurationsApi.
 * @export
 * @interface SearchCurationsApiApiV1SearchcurationsLanguageCodeParentIdSubitemsGetRequest
 */
export interface SearchCurationsApiApiV1SearchcurationsLanguageCodeParentIdSubitemsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SearchCurationsApiApiV1SearchcurationsLanguageCodeParentIdSubitemsGet
     */
    readonly languageCode: string

    /**
     * 
     * @type {string}
     * @memberof SearchCurationsApiApiV1SearchcurationsLanguageCodeParentIdSubitemsGet
     */
    readonly parentId: string
}

/**
 * Request parameters for apiV1SearchcurationsLanguageCodePost operation in SearchCurationsApi.
 * @export
 * @interface SearchCurationsApiApiV1SearchcurationsLanguageCodePostRequest
 */
export interface SearchCurationsApiApiV1SearchcurationsLanguageCodePostRequest {
    /**
     * 
     * @type {string}
     * @memberof SearchCurationsApiApiV1SearchcurationsLanguageCodePost
     */
    readonly languageCode: string

    /**
     * 
     * @type {SaveSearchCurationsCommand}
     * @memberof SearchCurationsApiApiV1SearchcurationsLanguageCodePost
     */
    readonly saveSearchCurationsCommand?: SaveSearchCurationsCommand
}

/**
 * Request parameters for apiV1SearchcurationsSlugRevalidatePost operation in SearchCurationsApi.
 * @export
 * @interface SearchCurationsApiApiV1SearchcurationsSlugRevalidatePostRequest
 */
export interface SearchCurationsApiApiV1SearchcurationsSlugRevalidatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof SearchCurationsApiApiV1SearchcurationsSlugRevalidatePost
     */
    readonly slug: string

    /**
     * 
     * @type {string}
     * @memberof SearchCurationsApiApiV1SearchcurationsSlugRevalidatePost
     */
    readonly languageCode?: string
}

/**
 * SearchCurationsApi - object-oriented interface
 * @export
 * @class SearchCurationsApi
 * @extends {BaseAPI}
 */
export class SearchCurationsApi extends BaseAPI {
    /**
     * 
     * @summary Get all SearchCurationItems
     * @param {SearchCurationsApiApiV1SearchcurationsLanguageCodeGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchCurationsApi
     */
    public apiV1SearchcurationsLanguageCodeGet(requestParameters: SearchCurationsApiApiV1SearchcurationsLanguageCodeGetRequest, options?: AxiosRequestConfig) {
        return SearchCurationsApiFp(this.configuration).apiV1SearchcurationsLanguageCodeGet(requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete SearchCurationItem
     * @param {SearchCurationsApiApiV1SearchcurationsLanguageCodeIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchCurationsApi
     */
    public apiV1SearchcurationsLanguageCodeIdDelete(requestParameters: SearchCurationsApiApiV1SearchcurationsLanguageCodeIdDeleteRequest, options?: AxiosRequestConfig) {
        return SearchCurationsApiFp(this.configuration).apiV1SearchcurationsLanguageCodeIdDelete(requestParameters.languageCode, requestParameters.id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get SearchCurationItem by id
     * @param {SearchCurationsApiApiV1SearchcurationsLanguageCodeIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchCurationsApi
     */
    public apiV1SearchcurationsLanguageCodeIdGet(requestParameters: SearchCurationsApiApiV1SearchcurationsLanguageCodeIdGetRequest, options?: AxiosRequestConfig) {
        return SearchCurationsApiFp(this.configuration).apiV1SearchcurationsLanguageCodeIdGet(requestParameters.languageCode, requestParameters.id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get SearchCurationItems by parent id
     * @param {SearchCurationsApiApiV1SearchcurationsLanguageCodeParentIdSubitemsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchCurationsApi
     */
    public apiV1SearchcurationsLanguageCodeParentIdSubitemsGet(requestParameters: SearchCurationsApiApiV1SearchcurationsLanguageCodeParentIdSubitemsGetRequest, options?: AxiosRequestConfig) {
        return SearchCurationsApiFp(this.configuration).apiV1SearchcurationsLanguageCodeParentIdSubitemsGet(requestParameters.languageCode, requestParameters.parentId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Save SearchCurationItem
     * @param {SearchCurationsApiApiV1SearchcurationsLanguageCodePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchCurationsApi
     */
    public apiV1SearchcurationsLanguageCodePost(requestParameters: SearchCurationsApiApiV1SearchcurationsLanguageCodePostRequest, options?: AxiosRequestConfig) {
        return SearchCurationsApiFp(this.configuration).apiV1SearchcurationsLanguageCodePost(requestParameters.languageCode, requestParameters.saveSearchCurationsCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revalidate searchCurationItem
     * @param {SearchCurationsApiApiV1SearchcurationsSlugRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchCurationsApi
     */
    public apiV1SearchcurationsSlugRevalidatePost(requestParameters: SearchCurationsApiApiV1SearchcurationsSlugRevalidatePostRequest, options?: AxiosRequestConfig) {
        return SearchCurationsApiFp(this.configuration).apiV1SearchcurationsSlugRevalidatePost(requestParameters.slug, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }
}
