/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateDoctorCertificateCommand } from '../models';
// @ts-ignore
import { CreateDoctorCommand } from '../models';
// @ts-ignore
import { CreateDoctorEducationCommand } from '../models';
// @ts-ignore
import { CreateDoctorLanguageCommand } from '../models';
// @ts-ignore
import { CreateDoctorPortfolioCommand } from '../models';
// @ts-ignore
import { CreateDoctorSpecialtyCommand } from '../models';
// @ts-ignore
import { CreateMediaCommand } from '../models';
// @ts-ignore
import { DoctorCertificateModel } from '../models';
// @ts-ignore
import { DoctorCertificateSortingCommand } from '../models';
// @ts-ignore
import { DoctorCertificatesModel } from '../models';
// @ts-ignore
import { DoctorEducationModel } from '../models';
// @ts-ignore
import { DoctorEducationSortingCommand } from '../models';
// @ts-ignore
import { DoctorEducationsModel } from '../models';
// @ts-ignore
import { DoctorLanguageModel } from '../models';
// @ts-ignore
import { DoctorLanguagesModel } from '../models';
// @ts-ignore
import { DoctorModel } from '../models';
// @ts-ignore
import { DoctorPortfolioModel } from '../models';
// @ts-ignore
import { DoctorPortfoliosModel } from '../models';
// @ts-ignore
import { DoctorSpecialtiesModel } from '../models';
// @ts-ignore
import { DoctorSpecialtyModel } from '../models';
// @ts-ignore
import { DoctorsModel } from '../models';
// @ts-ignore
import { DoctorsSimpleModel } from '../models';
// @ts-ignore
import { Gender } from '../models';
// @ts-ignore
import { MediaModel } from '../models';
// @ts-ignore
import { MediaType } from '../models';
// @ts-ignore
import { MediasModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SortingResultModel } from '../models';
// @ts-ignore
import { UpdateDoctorCertificateCommand } from '../models';
// @ts-ignore
import { UpdateDoctorCommand } from '../models';
// @ts-ignore
import { UpdateDoctorEducationCommand } from '../models';
// @ts-ignore
import { UpdateDoctorLanguageCommand } from '../models';
// @ts-ignore
import { UpdateDoctorPortfolioCommand } from '../models';
// @ts-ignore
import { UpdateDoctorSpecialtyCommand } from '../models';
// @ts-ignore
import { UpdateMediaCommand } from '../models';
/**
 * DoctorsApi - axios parameter creator
 * @export
 */
export const DoctorsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} certificateId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesCertificateIdDelete: async (doctorId: string, certificateId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdCertificatesCertificateIdDelete', 'doctorId', doctorId)
            // verify required parameter 'certificateId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdCertificatesCertificateIdDelete', 'certificateId', certificateId)
            const localVarPath = `/api/v1/doctors/{doctorId}/certificates/{certificateId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"certificateId"}}`, encodeURIComponent(String(certificateId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} certificateId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesCertificateIdGet: async (doctorId: string, certificateId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdCertificatesCertificateIdGet', 'doctorId', doctorId)
            // verify required parameter 'certificateId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdCertificatesCertificateIdGet', 'certificateId', certificateId)
            const localVarPath = `/api/v1/doctors/{doctorId}/certificates/{certificateId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"certificateId"}}`, encodeURIComponent(String(certificateId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} certificateId 
         * @param {UpdateDoctorCertificateCommand} [updateDoctorCertificateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesCertificateIdPut: async (doctorId: string, certificateId: string, updateDoctorCertificateCommand?: UpdateDoctorCertificateCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdCertificatesCertificateIdPut', 'doctorId', doctorId)
            // verify required parameter 'certificateId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdCertificatesCertificateIdPut', 'certificateId', certificateId)
            const localVarPath = `/api/v1/doctors/{doctorId}/certificates/{certificateId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"certificateId"}}`, encodeURIComponent(String(certificateId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateDoctorCertificateCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} [doctorName] 
         * @param {string} [certificateId] 
         * @param {string} [certificate] 
         * @param {Date} [activeFrom] 
         * @param {Date} [activeTo] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesGet: async (doctorId: string, doctorName?: string, certificateId?: string, certificate?: string, activeFrom?: Date, activeTo?: Date, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdCertificatesGet', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/certificates`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (doctorName !== undefined) {
                localVarQueryParameter['DoctorName'] = doctorName;
            }

            if (certificateId !== undefined) {
                localVarQueryParameter['CertificateId'] = certificateId;
            }

            if (certificate !== undefined) {
                localVarQueryParameter['Certificate'] = certificate;
            }

            if (activeFrom !== undefined) {
                localVarQueryParameter['ActiveFrom'] = (activeFrom as any instanceof Date) ?
                    (activeFrom as any).toISOString() :
                    activeFrom;
            }

            if (activeTo !== undefined) {
                localVarQueryParameter['ActiveTo'] = (activeTo as any instanceof Date) ?
                    (activeTo as any).toISOString() :
                    activeTo;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create DoctorCertificate.
         * @param {string} doctorId 
         * @param {CreateDoctorCertificateCommand} [createDoctorCertificateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesPost: async (doctorId: string, createDoctorCertificateCommand?: CreateDoctorCertificateCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdCertificatesPost', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/certificates`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createDoctorCertificateCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Batch for doctor certificates sorting
         * @param {string} doctorId 
         * @param {DoctorCertificateSortingCommand} [doctorCertificateSortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesSortPut: async (doctorId: string, doctorCertificateSortingCommand?: DoctorCertificateSortingCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdCertificatesSortPut', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/certificates/sort`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(doctorCertificateSortingCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Doctor.
         * @param {string} doctorId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdDelete: async (doctorId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdDelete', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete DoctorEducation
         * @param {string} doctorId 
         * @param {string} educationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsEducationIdDelete: async (doctorId: string, educationId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdEducationsEducationIdDelete', 'doctorId', doctorId)
            // verify required parameter 'educationId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdEducationsEducationIdDelete', 'educationId', educationId)
            const localVarPath = `/api/v1/doctors/{doctorId}/educations/{educationId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"educationId"}}`, encodeURIComponent(String(educationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DoctorEducation.
         * @param {string} doctorId 
         * @param {string} educationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsEducationIdGet: async (doctorId: string, educationId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdEducationsEducationIdGet', 'doctorId', doctorId)
            // verify required parameter 'educationId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdEducationsEducationIdGet', 'educationId', educationId)
            const localVarPath = `/api/v1/doctors/{doctorId}/educations/{educationId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"educationId"}}`, encodeURIComponent(String(educationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update DoctorEducation.
         * @param {string} doctorId 
         * @param {string} educationId 
         * @param {UpdateDoctorEducationCommand} [updateDoctorEducationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsEducationIdPut: async (doctorId: string, educationId: string, updateDoctorEducationCommand?: UpdateDoctorEducationCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdEducationsEducationIdPut', 'doctorId', doctorId)
            // verify required parameter 'educationId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdEducationsEducationIdPut', 'educationId', educationId)
            const localVarPath = `/api/v1/doctors/{doctorId}/educations/{educationId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"educationId"}}`, encodeURIComponent(String(educationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateDoctorEducationCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all DoctorEducations.
         * @param {string} doctorId 
         * @param {string} [doctorName] 
         * @param {string} [educationId] 
         * @param {string} [institution] 
         * @param {string} [qualification] 
         * @param {Date} [graduationDate] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsGet: async (doctorId: string, doctorName?: string, educationId?: string, institution?: string, qualification?: string, graduationDate?: Date, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdEducationsGet', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/educations`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (doctorName !== undefined) {
                localVarQueryParameter['DoctorName'] = doctorName;
            }

            if (educationId !== undefined) {
                localVarQueryParameter['EducationId'] = educationId;
            }

            if (institution !== undefined) {
                localVarQueryParameter['Institution'] = institution;
            }

            if (qualification !== undefined) {
                localVarQueryParameter['Qualification'] = qualification;
            }

            if (graduationDate !== undefined) {
                localVarQueryParameter['GraduationDate'] = (graduationDate as any instanceof Date) ?
                    (graduationDate as any).toISOString() :
                    graduationDate;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create DoctorEducation.
         * @param {string} doctorId 
         * @param {CreateDoctorEducationCommand} [createDoctorEducationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsPost: async (doctorId: string, createDoctorEducationCommand?: CreateDoctorEducationCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdEducationsPost', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/educations`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createDoctorEducationCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Batch for doctor educations sorting
         * @param {string} doctorId 
         * @param {DoctorEducationSortingCommand} [doctorEducationSortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsSortPut: async (doctorId: string, doctorEducationSortingCommand?: DoctorEducationSortingCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdEducationsSortPut', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/educations/sort`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(doctorEducationSortingCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get doctor
         * @param {string} doctorId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdGet: async (doctorId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdGet', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all DoctorLanguages.
         * @param {string} doctorId 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdLanguagesGet: async (doctorId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdLanguagesGet', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/languages`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete DoctorLanguage
         * @param {string} doctorId 
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdLanguagesLanguageCodeDelete: async (doctorId: string, languageCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdLanguagesLanguageCodeDelete', 'doctorId', doctorId)
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdLanguagesLanguageCodeDelete', 'languageCode', languageCode)
            const localVarPath = `/api/v1/doctors/{doctorId}/languages/{languageCode}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DoctorLanguage.
         * @param {string} doctorId 
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdLanguagesLanguageCodeGet: async (doctorId: string, languageCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdLanguagesLanguageCodeGet', 'doctorId', doctorId)
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdLanguagesLanguageCodeGet', 'languageCode', languageCode)
            const localVarPath = `/api/v1/doctors/{doctorId}/languages/{languageCode}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update DoctorLanguage.
         * @param {string} doctorId 
         * @param {string} languageCode 
         * @param {UpdateDoctorLanguageCommand} [updateDoctorLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdLanguagesLanguageCodePut: async (doctorId: string, languageCode: string, updateDoctorLanguageCommand?: UpdateDoctorLanguageCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdLanguagesLanguageCodePut', 'doctorId', doctorId)
            // verify required parameter 'languageCode' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdLanguagesLanguageCodePut', 'languageCode', languageCode)
            const localVarPath = `/api/v1/doctors/{doctorId}/languages/{languageCode}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"languageCode"}}`, encodeURIComponent(String(languageCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateDoctorLanguageCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create DoctorLanguage.
         * @param {string} doctorId 
         * @param {CreateDoctorLanguageCommand} [createDoctorLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdLanguagesPost: async (doctorId: string, createDoctorLanguageCommand?: CreateDoctorLanguageCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdLanguagesPost', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/languages`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createDoctorLanguageCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all DoctorMedias.
         * @param {string} doctorId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdMediasGet: async (doctorId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdMediasGet', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/medias`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (mediaType !== undefined) {
                localVarQueryParameter['MediaType'] = mediaType;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete DoctorMedia
         * @param {string} doctorId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdMediasMediaIdDelete: async (doctorId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdMediasMediaIdDelete', 'doctorId', doctorId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdMediasMediaIdDelete', 'mediaId', mediaId)
            const localVarPath = `/api/v1/doctors/{doctorId}/medias/{mediaId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DoctorMedia.
         * @param {string} doctorId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdMediasMediaIdGet: async (doctorId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdMediasMediaIdGet', 'doctorId', doctorId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdMediasMediaIdGet', 'mediaId', mediaId)
            const localVarPath = `/api/v1/doctors/{doctorId}/medias/{mediaId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update DoctorMedia.
         * @param {string} doctorId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdMediasMediaIdPut: async (doctorId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdMediasMediaIdPut', 'doctorId', doctorId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdMediasMediaIdPut', 'mediaId', mediaId)
            const localVarPath = `/api/v1/doctors/{doctorId}/medias/{mediaId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create DoctorMedia.
         * @param {string} doctorId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdMediasPost: async (doctorId: string, createMediaCommand?: CreateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdMediasPost', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/medias`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get All DoctorPortfolios
         * @param {string} doctorId 
         * @param {string} [doctorName] 
         * @param {string} [portfolioId] 
         * @param {string} [name] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPortfoliosGet: async (doctorId: string, doctorName?: string, portfolioId?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdPortfoliosGet', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/portfolios`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (doctorName !== undefined) {
                localVarQueryParameter['DoctorName'] = doctorName;
            }

            if (portfolioId !== undefined) {
                localVarQueryParameter['PortfolioId'] = portfolioId;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete DoctorPortfolio.
         * @param {string} doctorId 
         * @param {string} portfolioId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete: async (doctorId: string, portfolioId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete', 'doctorId', doctorId)
            // verify required parameter 'portfolioId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete', 'portfolioId', portfolioId)
            const localVarPath = `/api/v1/doctors/{doctorId}/portfolios/{portfolioId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"portfolioId"}}`, encodeURIComponent(String(portfolioId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DoctorPortfolio.
         * @param {string} doctorId 
         * @param {string} portfolioId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPortfoliosPortfolioIdGet: async (doctorId: string, portfolioId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdPortfoliosPortfolioIdGet', 'doctorId', doctorId)
            // verify required parameter 'portfolioId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdPortfoliosPortfolioIdGet', 'portfolioId', portfolioId)
            const localVarPath = `/api/v1/doctors/{doctorId}/portfolios/{portfolioId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"portfolioId"}}`, encodeURIComponent(String(portfolioId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update DoctorPortfolio.
         * @param {string} doctorId 
         * @param {string} portfolioId 
         * @param {UpdateDoctorPortfolioCommand} [updateDoctorPortfolioCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPortfoliosPortfolioIdPut: async (doctorId: string, portfolioId: string, updateDoctorPortfolioCommand?: UpdateDoctorPortfolioCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdPortfoliosPortfolioIdPut', 'doctorId', doctorId)
            // verify required parameter 'portfolioId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdPortfoliosPortfolioIdPut', 'portfolioId', portfolioId)
            const localVarPath = `/api/v1/doctors/{doctorId}/portfolios/{portfolioId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"portfolioId"}}`, encodeURIComponent(String(portfolioId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateDoctorPortfolioCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create DoctorPortfolio.
         * @param {string} doctorId 
         * @param {CreateDoctorPortfolioCommand} [createDoctorPortfolioCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPortfoliosPost: async (doctorId: string, createDoctorPortfolioCommand?: CreateDoctorPortfolioCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdPortfoliosPost', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/portfolios`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createDoctorPortfolioCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Doctor.
         * @param {string} doctorId 
         * @param {UpdateDoctorCommand} [updateDoctorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPut: async (doctorId: string, updateDoctorCommand?: UpdateDoctorCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdPut', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateDoctorCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Doctor.
         * @param {string} doctorId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdReactivatePut: async (doctorId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdReactivatePut', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/reactivate`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revalidate doctor
         * @param {string} doctorId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdRevalidatePost: async (doctorId: string, includeCurrent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdRevalidatePost', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/revalidate`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (includeCurrent !== undefined) {
                localVarQueryParameter['includeCurrent'] = includeCurrent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get All DoctorSpecialties.
         * @param {string} doctorId 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdSpecialtiesGet: async (doctorId: string, specialtyId?: string, specialtyName?: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdSpecialtiesGet', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/specialties`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (specialtyId !== undefined) {
                localVarQueryParameter['SpecialtyId'] = specialtyId;
            }

            if (specialtyName !== undefined) {
                localVarQueryParameter['SpecialtyName'] = specialtyName;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Link a doctor to a specialty.
         * @param {string} doctorId 
         * @param {CreateDoctorSpecialtyCommand} [createDoctorSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdSpecialtiesPost: async (doctorId: string, createDoctorSpecialtyCommand?: CreateDoctorSpecialtyCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdSpecialtiesPost', 'doctorId', doctorId)
            const localVarPath = `/api/v1/doctors/{doctorId}/specialties`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createDoctorSpecialtyCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Remove link between the doctor and the specialty.
         * @param {string} doctorId 
         * @param {string} specialtyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete: async (doctorId: string, specialtyId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete', 'doctorId', doctorId)
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/doctors/{doctorId}/specialties/{specialtyId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get DoctorSpecialty
         * @param {string} doctorId 
         * @param {string} specialtyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet: async (doctorId: string, specialtyId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet', 'doctorId', doctorId)
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/doctors/{doctorId}/specialties/{specialtyId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update DoctorSpecialty.
         * @param {string} doctorId 
         * @param {string} specialtyId 
         * @param {UpdateDoctorSpecialtyCommand} [updateDoctorSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut: async (doctorId: string, specialtyId: string, updateDoctorSpecialtyCommand?: UpdateDoctorSpecialtyCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'doctorId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut', 'doctorId', doctorId)
            // verify required parameter 'specialtyId' is not null or undefined
            assertParamExists('apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut', 'specialtyId', specialtyId)
            const localVarPath = `/api/v1/doctors/{doctorId}/specialties/{specialtyId}`
                .replace(`{${"doctorId"}}`, encodeURIComponent(String(doctorId)))
                .replace(`{${"specialtyId"}}`, encodeURIComponent(String(specialtyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateDoctorSpecialtyCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all Doctors.
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyId] 
         * @param {boolean} [consultationEnabled] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsGet: async (hospitalId?: string, hospitalName?: string, ids?: Array<string>, specialtyId?: string, consultationEnabled?: boolean, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/doctors`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (ids) {
                localVarQueryParameter['Ids'] = ids;
            }

            if (specialtyId !== undefined) {
                localVarQueryParameter['SpecialtyId'] = specialtyId;
            }

            if (consultationEnabled !== undefined) {
                localVarQueryParameter['ConsultationEnabled'] = consultationEnabled;
            }

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (fullname !== undefined) {
                localVarQueryParameter['Fullname'] = fullname;
            }

            if (email !== undefined) {
                localVarQueryParameter['Email'] = email;
            }

            if (gender !== undefined) {
                localVarQueryParameter['Gender'] = gender;
            }

            if (dateOfBirth !== undefined) {
                localVarQueryParameter['DateOfBirth'] = (dateOfBirth as any instanceof Date) ?
                    (dateOfBirth as any).toISOString() :
                    dateOfBirth;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a Doctor.
         * @param {CreateDoctorCommand} [createDoctorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsPost: async (createDoctorCommand?: CreateDoctorCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/doctors`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createDoctorCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all Doctors.
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyId] 
         * @param {boolean} [consultationEnabled] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsSimpleGet: async (hospitalId?: string, hospitalName?: string, ids?: Array<string>, specialtyId?: string, consultationEnabled?: boolean, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/doctors/simple`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (ids) {
                localVarQueryParameter['Ids'] = ids;
            }

            if (specialtyId !== undefined) {
                localVarQueryParameter['SpecialtyId'] = specialtyId;
            }

            if (consultationEnabled !== undefined) {
                localVarQueryParameter['ConsultationEnabled'] = consultationEnabled;
            }

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (fullname !== undefined) {
                localVarQueryParameter['Fullname'] = fullname;
            }

            if (email !== undefined) {
                localVarQueryParameter['Email'] = email;
            }

            if (gender !== undefined) {
                localVarQueryParameter['Gender'] = gender;
            }

            if (dateOfBirth !== undefined) {
                localVarQueryParameter['DateOfBirth'] = (dateOfBirth as any instanceof Date) ?
                    (dateOfBirth as any).toISOString() :
                    dateOfBirth;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * DoctorsApi - functional programming interface
 * @export
 */
export const DoctorsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = DoctorsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} certificateId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdCertificatesCertificateIdDelete(doctorId: string, certificateId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdCertificatesCertificateIdDelete(doctorId, certificateId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} certificateId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdCertificatesCertificateIdGet(doctorId: string, certificateId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorCertificateModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdCertificatesCertificateIdGet(doctorId, certificateId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} certificateId 
         * @param {UpdateDoctorCertificateCommand} [updateDoctorCertificateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdCertificatesCertificateIdPut(doctorId: string, certificateId: string, updateDoctorCertificateCommand?: UpdateDoctorCertificateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorCertificateModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdCertificatesCertificateIdPut(doctorId, certificateId, updateDoctorCertificateCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} [doctorName] 
         * @param {string} [certificateId] 
         * @param {string} [certificate] 
         * @param {Date} [activeFrom] 
         * @param {Date} [activeTo] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdCertificatesGet(doctorId: string, doctorName?: string, certificateId?: string, certificate?: string, activeFrom?: Date, activeTo?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorCertificatesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdCertificatesGet(doctorId, doctorName, certificateId, certificate, activeFrom, activeTo, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create DoctorCertificate.
         * @param {string} doctorId 
         * @param {CreateDoctorCertificateCommand} [createDoctorCertificateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdCertificatesPost(doctorId: string, createDoctorCertificateCommand?: CreateDoctorCertificateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorCertificateModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdCertificatesPost(doctorId, createDoctorCertificateCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Batch for doctor certificates sorting
         * @param {string} doctorId 
         * @param {DoctorCertificateSortingCommand} [doctorCertificateSortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdCertificatesSortPut(doctorId: string, doctorCertificateSortingCommand?: DoctorCertificateSortingCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SortingResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdCertificatesSortPut(doctorId, doctorCertificateSortingCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Doctor.
         * @param {string} doctorId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdDelete(doctorId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdDelete(doctorId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete DoctorEducation
         * @param {string} doctorId 
         * @param {string} educationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdEducationsEducationIdDelete(doctorId: string, educationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdEducationsEducationIdDelete(doctorId, educationId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DoctorEducation.
         * @param {string} doctorId 
         * @param {string} educationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdEducationsEducationIdGet(doctorId: string, educationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorEducationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdEducationsEducationIdGet(doctorId, educationId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update DoctorEducation.
         * @param {string} doctorId 
         * @param {string} educationId 
         * @param {UpdateDoctorEducationCommand} [updateDoctorEducationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdEducationsEducationIdPut(doctorId: string, educationId: string, updateDoctorEducationCommand?: UpdateDoctorEducationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorEducationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdEducationsEducationIdPut(doctorId, educationId, updateDoctorEducationCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all DoctorEducations.
         * @param {string} doctorId 
         * @param {string} [doctorName] 
         * @param {string} [educationId] 
         * @param {string} [institution] 
         * @param {string} [qualification] 
         * @param {Date} [graduationDate] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdEducationsGet(doctorId: string, doctorName?: string, educationId?: string, institution?: string, qualification?: string, graduationDate?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorEducationsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdEducationsGet(doctorId, doctorName, educationId, institution, qualification, graduationDate, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create DoctorEducation.
         * @param {string} doctorId 
         * @param {CreateDoctorEducationCommand} [createDoctorEducationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdEducationsPost(doctorId: string, createDoctorEducationCommand?: CreateDoctorEducationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorEducationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdEducationsPost(doctorId, createDoctorEducationCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Batch for doctor educations sorting
         * @param {string} doctorId 
         * @param {DoctorEducationSortingCommand} [doctorEducationSortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdEducationsSortPut(doctorId: string, doctorEducationSortingCommand?: DoctorEducationSortingCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SortingResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdEducationsSortPut(doctorId, doctorEducationSortingCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get doctor
         * @param {string} doctorId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdGet(doctorId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdGet(doctorId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all DoctorLanguages.
         * @param {string} doctorId 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdLanguagesGet(doctorId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorLanguagesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdLanguagesGet(doctorId, languageCode, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete DoctorLanguage
         * @param {string} doctorId 
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdLanguagesLanguageCodeDelete(doctorId: string, languageCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdLanguagesLanguageCodeDelete(doctorId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DoctorLanguage.
         * @param {string} doctorId 
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdLanguagesLanguageCodeGet(doctorId: string, languageCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorLanguageModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdLanguagesLanguageCodeGet(doctorId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update DoctorLanguage.
         * @param {string} doctorId 
         * @param {string} languageCode 
         * @param {UpdateDoctorLanguageCommand} [updateDoctorLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdLanguagesLanguageCodePut(doctorId: string, languageCode: string, updateDoctorLanguageCommand?: UpdateDoctorLanguageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdLanguagesLanguageCodePut(doctorId, languageCode, updateDoctorLanguageCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create DoctorLanguage.
         * @param {string} doctorId 
         * @param {CreateDoctorLanguageCommand} [createDoctorLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdLanguagesPost(doctorId: string, createDoctorLanguageCommand?: CreateDoctorLanguageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdLanguagesPost(doctorId, createDoctorLanguageCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all DoctorMedias.
         * @param {string} doctorId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdMediasGet(doctorId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediasModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdMediasGet(doctorId, id, mediaType, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete DoctorMedia
         * @param {string} doctorId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdMediasMediaIdDelete(doctorId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdMediasMediaIdDelete(doctorId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DoctorMedia.
         * @param {string} doctorId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdMediasMediaIdGet(doctorId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdMediasMediaIdGet(doctorId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update DoctorMedia.
         * @param {string} doctorId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdMediasMediaIdPut(doctorId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdMediasMediaIdPut(doctorId, mediaId, updateMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create DoctorMedia.
         * @param {string} doctorId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdMediasPost(doctorId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdMediasPost(doctorId, createMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get All DoctorPortfolios
         * @param {string} doctorId 
         * @param {string} [doctorName] 
         * @param {string} [portfolioId] 
         * @param {string} [name] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdPortfoliosGet(doctorId: string, doctorName?: string, portfolioId?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorPortfoliosModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdPortfoliosGet(doctorId, doctorName, portfolioId, name, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete DoctorPortfolio.
         * @param {string} doctorId 
         * @param {string} portfolioId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete(doctorId: string, portfolioId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete(doctorId, portfolioId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DoctorPortfolio.
         * @param {string} doctorId 
         * @param {string} portfolioId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdPortfoliosPortfolioIdGet(doctorId: string, portfolioId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorPortfolioModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdPortfoliosPortfolioIdGet(doctorId, portfolioId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update DoctorPortfolio.
         * @param {string} doctorId 
         * @param {string} portfolioId 
         * @param {UpdateDoctorPortfolioCommand} [updateDoctorPortfolioCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdPortfoliosPortfolioIdPut(doctorId: string, portfolioId: string, updateDoctorPortfolioCommand?: UpdateDoctorPortfolioCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorPortfolioModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdPortfoliosPortfolioIdPut(doctorId, portfolioId, updateDoctorPortfolioCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create DoctorPortfolio.
         * @param {string} doctorId 
         * @param {CreateDoctorPortfolioCommand} [createDoctorPortfolioCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdPortfoliosPost(doctorId: string, createDoctorPortfolioCommand?: CreateDoctorPortfolioCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorPortfolioModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdPortfoliosPost(doctorId, createDoctorPortfolioCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Doctor.
         * @param {string} doctorId 
         * @param {UpdateDoctorCommand} [updateDoctorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdPut(doctorId: string, updateDoctorCommand?: UpdateDoctorCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdPut(doctorId, updateDoctorCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Doctor.
         * @param {string} doctorId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdReactivatePut(doctorId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdReactivatePut(doctorId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revalidate doctor
         * @param {string} doctorId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdRevalidatePost(doctorId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdRevalidatePost(doctorId, includeCurrent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get All DoctorSpecialties.
         * @param {string} doctorId 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdSpecialtiesGet(doctorId: string, specialtyId?: string, specialtyName?: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorSpecialtiesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdSpecialtiesGet(doctorId, specialtyId, specialtyName, languageCode, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Link a doctor to a specialty.
         * @param {string} doctorId 
         * @param {CreateDoctorSpecialtyCommand} [createDoctorSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdSpecialtiesPost(doctorId: string, createDoctorSpecialtyCommand?: CreateDoctorSpecialtyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorSpecialtyModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdSpecialtiesPost(doctorId, createDoctorSpecialtyCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Remove link between the doctor and the specialty.
         * @param {string} doctorId 
         * @param {string} specialtyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete(doctorId: string, specialtyId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete(doctorId, specialtyId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get DoctorSpecialty
         * @param {string} doctorId 
         * @param {string} specialtyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet(doctorId: string, specialtyId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorSpecialtyModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet(doctorId, specialtyId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update DoctorSpecialty.
         * @param {string} doctorId 
         * @param {string} specialtyId 
         * @param {UpdateDoctorSpecialtyCommand} [updateDoctorSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut(doctorId: string, specialtyId: string, updateDoctorSpecialtyCommand?: UpdateDoctorSpecialtyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorSpecialtyModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut(doctorId, specialtyId, updateDoctorSpecialtyCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all Doctors.
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyId] 
         * @param {boolean} [consultationEnabled] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsGet(hospitalId?: string, hospitalName?: string, ids?: Array<string>, specialtyId?: string, consultationEnabled?: boolean, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsGet(hospitalId, hospitalName, ids, specialtyId, consultationEnabled, id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a Doctor.
         * @param {CreateDoctorCommand} [createDoctorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsPost(createDoctorCommand?: CreateDoctorCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsPost(createDoctorCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all Doctors.
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyId] 
         * @param {boolean} [consultationEnabled] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1DoctorsSimpleGet(hospitalId?: string, hospitalName?: string, ids?: Array<string>, specialtyId?: string, consultationEnabled?: boolean, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoctorsSimpleModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1DoctorsSimpleGet(hospitalId, hospitalName, ids, specialtyId, consultationEnabled, id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * DoctorsApi - factory interface
 * @export
 */
export const DoctorsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = DoctorsApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} certificateId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesCertificateIdDelete(doctorId: string, certificateId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdCertificatesCertificateIdDelete(doctorId, certificateId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} certificateId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesCertificateIdGet(doctorId: string, certificateId: string, options?: any): AxiosPromise<DoctorCertificateModel> {
            return localVarFp.apiV1DoctorsDoctorIdCertificatesCertificateIdGet(doctorId, certificateId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} certificateId 
         * @param {UpdateDoctorCertificateCommand} [updateDoctorCertificateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesCertificateIdPut(doctorId: string, certificateId: string, updateDoctorCertificateCommand?: UpdateDoctorCertificateCommand, options?: any): AxiosPromise<DoctorCertificateModel> {
            return localVarFp.apiV1DoctorsDoctorIdCertificatesCertificateIdPut(doctorId, certificateId, updateDoctorCertificateCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete DoctorCertificate.
         * @param {string} doctorId 
         * @param {string} [doctorName] 
         * @param {string} [certificateId] 
         * @param {string} [certificate] 
         * @param {Date} [activeFrom] 
         * @param {Date} [activeTo] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesGet(doctorId: string, doctorName?: string, certificateId?: string, certificate?: string, activeFrom?: Date, activeTo?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DoctorCertificatesModel> {
            return localVarFp.apiV1DoctorsDoctorIdCertificatesGet(doctorId, doctorName, certificateId, certificate, activeFrom, activeTo, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create DoctorCertificate.
         * @param {string} doctorId 
         * @param {CreateDoctorCertificateCommand} [createDoctorCertificateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesPost(doctorId: string, createDoctorCertificateCommand?: CreateDoctorCertificateCommand, options?: any): AxiosPromise<DoctorCertificateModel> {
            return localVarFp.apiV1DoctorsDoctorIdCertificatesPost(doctorId, createDoctorCertificateCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Batch for doctor certificates sorting
         * @param {string} doctorId 
         * @param {DoctorCertificateSortingCommand} [doctorCertificateSortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdCertificatesSortPut(doctorId: string, doctorCertificateSortingCommand?: DoctorCertificateSortingCommand, options?: any): AxiosPromise<SortingResultModel> {
            return localVarFp.apiV1DoctorsDoctorIdCertificatesSortPut(doctorId, doctorCertificateSortingCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Doctor.
         * @param {string} doctorId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdDelete(doctorId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdDelete(doctorId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete DoctorEducation
         * @param {string} doctorId 
         * @param {string} educationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsEducationIdDelete(doctorId: string, educationId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdEducationsEducationIdDelete(doctorId, educationId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DoctorEducation.
         * @param {string} doctorId 
         * @param {string} educationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsEducationIdGet(doctorId: string, educationId: string, options?: any): AxiosPromise<DoctorEducationModel> {
            return localVarFp.apiV1DoctorsDoctorIdEducationsEducationIdGet(doctorId, educationId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update DoctorEducation.
         * @param {string} doctorId 
         * @param {string} educationId 
         * @param {UpdateDoctorEducationCommand} [updateDoctorEducationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsEducationIdPut(doctorId: string, educationId: string, updateDoctorEducationCommand?: UpdateDoctorEducationCommand, options?: any): AxiosPromise<DoctorEducationModel> {
            return localVarFp.apiV1DoctorsDoctorIdEducationsEducationIdPut(doctorId, educationId, updateDoctorEducationCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all DoctorEducations.
         * @param {string} doctorId 
         * @param {string} [doctorName] 
         * @param {string} [educationId] 
         * @param {string} [institution] 
         * @param {string} [qualification] 
         * @param {Date} [graduationDate] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsGet(doctorId: string, doctorName?: string, educationId?: string, institution?: string, qualification?: string, graduationDate?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DoctorEducationsModel> {
            return localVarFp.apiV1DoctorsDoctorIdEducationsGet(doctorId, doctorName, educationId, institution, qualification, graduationDate, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create DoctorEducation.
         * @param {string} doctorId 
         * @param {CreateDoctorEducationCommand} [createDoctorEducationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsPost(doctorId: string, createDoctorEducationCommand?: CreateDoctorEducationCommand, options?: any): AxiosPromise<DoctorEducationModel> {
            return localVarFp.apiV1DoctorsDoctorIdEducationsPost(doctorId, createDoctorEducationCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Batch for doctor educations sorting
         * @param {string} doctorId 
         * @param {DoctorEducationSortingCommand} [doctorEducationSortingCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdEducationsSortPut(doctorId: string, doctorEducationSortingCommand?: DoctorEducationSortingCommand, options?: any): AxiosPromise<SortingResultModel> {
            return localVarFp.apiV1DoctorsDoctorIdEducationsSortPut(doctorId, doctorEducationSortingCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get doctor
         * @param {string} doctorId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdGet(doctorId: string, options?: any): AxiosPromise<DoctorModel> {
            return localVarFp.apiV1DoctorsDoctorIdGet(doctorId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all DoctorLanguages.
         * @param {string} doctorId 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdLanguagesGet(doctorId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DoctorLanguagesModel> {
            return localVarFp.apiV1DoctorsDoctorIdLanguagesGet(doctorId, languageCode, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete DoctorLanguage
         * @param {string} doctorId 
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdLanguagesLanguageCodeDelete(doctorId: string, languageCode: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdLanguagesLanguageCodeDelete(doctorId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DoctorLanguage.
         * @param {string} doctorId 
         * @param {string} languageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdLanguagesLanguageCodeGet(doctorId: string, languageCode: string, options?: any): AxiosPromise<DoctorLanguageModel> {
            return localVarFp.apiV1DoctorsDoctorIdLanguagesLanguageCodeGet(doctorId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update DoctorLanguage.
         * @param {string} doctorId 
         * @param {string} languageCode 
         * @param {UpdateDoctorLanguageCommand} [updateDoctorLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdLanguagesLanguageCodePut(doctorId: string, languageCode: string, updateDoctorLanguageCommand?: UpdateDoctorLanguageCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdLanguagesLanguageCodePut(doctorId, languageCode, updateDoctorLanguageCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create DoctorLanguage.
         * @param {string} doctorId 
         * @param {CreateDoctorLanguageCommand} [createDoctorLanguageCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdLanguagesPost(doctorId: string, createDoctorLanguageCommand?: CreateDoctorLanguageCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdLanguagesPost(doctorId, createDoctorLanguageCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all DoctorMedias.
         * @param {string} doctorId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdMediasGet(doctorId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MediasModel> {
            return localVarFp.apiV1DoctorsDoctorIdMediasGet(doctorId, id, mediaType, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete DoctorMedia
         * @param {string} doctorId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdMediasMediaIdDelete(doctorId: string, mediaId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdMediasMediaIdDelete(doctorId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DoctorMedia.
         * @param {string} doctorId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdMediasMediaIdGet(doctorId: string, mediaId: string, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1DoctorsDoctorIdMediasMediaIdGet(doctorId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update DoctorMedia.
         * @param {string} doctorId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdMediasMediaIdPut(doctorId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1DoctorsDoctorIdMediasMediaIdPut(doctorId, mediaId, updateMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create DoctorMedia.
         * @param {string} doctorId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdMediasPost(doctorId: string, createMediaCommand?: CreateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1DoctorsDoctorIdMediasPost(doctorId, createMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get All DoctorPortfolios
         * @param {string} doctorId 
         * @param {string} [doctorName] 
         * @param {string} [portfolioId] 
         * @param {string} [name] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPortfoliosGet(doctorId: string, doctorName?: string, portfolioId?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DoctorPortfoliosModel> {
            return localVarFp.apiV1DoctorsDoctorIdPortfoliosGet(doctorId, doctorName, portfolioId, name, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete DoctorPortfolio.
         * @param {string} doctorId 
         * @param {string} portfolioId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete(doctorId: string, portfolioId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete(doctorId, portfolioId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DoctorPortfolio.
         * @param {string} doctorId 
         * @param {string} portfolioId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPortfoliosPortfolioIdGet(doctorId: string, portfolioId: string, options?: any): AxiosPromise<DoctorPortfolioModel> {
            return localVarFp.apiV1DoctorsDoctorIdPortfoliosPortfolioIdGet(doctorId, portfolioId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update DoctorPortfolio.
         * @param {string} doctorId 
         * @param {string} portfolioId 
         * @param {UpdateDoctorPortfolioCommand} [updateDoctorPortfolioCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPortfoliosPortfolioIdPut(doctorId: string, portfolioId: string, updateDoctorPortfolioCommand?: UpdateDoctorPortfolioCommand, options?: any): AxiosPromise<DoctorPortfolioModel> {
            return localVarFp.apiV1DoctorsDoctorIdPortfoliosPortfolioIdPut(doctorId, portfolioId, updateDoctorPortfolioCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create DoctorPortfolio.
         * @param {string} doctorId 
         * @param {CreateDoctorPortfolioCommand} [createDoctorPortfolioCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPortfoliosPost(doctorId: string, createDoctorPortfolioCommand?: CreateDoctorPortfolioCommand, options?: any): AxiosPromise<DoctorPortfolioModel> {
            return localVarFp.apiV1DoctorsDoctorIdPortfoliosPost(doctorId, createDoctorPortfolioCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Doctor.
         * @param {string} doctorId 
         * @param {UpdateDoctorCommand} [updateDoctorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdPut(doctorId: string, updateDoctorCommand?: UpdateDoctorCommand, options?: any): AxiosPromise<DoctorModel> {
            return localVarFp.apiV1DoctorsDoctorIdPut(doctorId, updateDoctorCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Doctor.
         * @param {string} doctorId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdReactivatePut(doctorId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdReactivatePut(doctorId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revalidate doctor
         * @param {string} doctorId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdRevalidatePost(doctorId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdRevalidatePost(doctorId, includeCurrent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get All DoctorSpecialties.
         * @param {string} doctorId 
         * @param {string} [specialtyId] 
         * @param {string} [specialtyName] 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdSpecialtiesGet(doctorId: string, specialtyId?: string, specialtyName?: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DoctorSpecialtiesModel> {
            return localVarFp.apiV1DoctorsDoctorIdSpecialtiesGet(doctorId, specialtyId, specialtyName, languageCode, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Link a doctor to a specialty.
         * @param {string} doctorId 
         * @param {CreateDoctorSpecialtyCommand} [createDoctorSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdSpecialtiesPost(doctorId: string, createDoctorSpecialtyCommand?: CreateDoctorSpecialtyCommand, options?: any): AxiosPromise<DoctorSpecialtyModel> {
            return localVarFp.apiV1DoctorsDoctorIdSpecialtiesPost(doctorId, createDoctorSpecialtyCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Remove link between the doctor and the specialty.
         * @param {string} doctorId 
         * @param {string} specialtyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete(doctorId: string, specialtyId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete(doctorId, specialtyId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get DoctorSpecialty
         * @param {string} doctorId 
         * @param {string} specialtyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet(doctorId: string, specialtyId: string, options?: any): AxiosPromise<DoctorSpecialtyModel> {
            return localVarFp.apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet(doctorId, specialtyId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update DoctorSpecialty.
         * @param {string} doctorId 
         * @param {string} specialtyId 
         * @param {UpdateDoctorSpecialtyCommand} [updateDoctorSpecialtyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut(doctorId: string, specialtyId: string, updateDoctorSpecialtyCommand?: UpdateDoctorSpecialtyCommand, options?: any): AxiosPromise<DoctorSpecialtyModel> {
            return localVarFp.apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut(doctorId, specialtyId, updateDoctorSpecialtyCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all Doctors.
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyId] 
         * @param {boolean} [consultationEnabled] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsGet(hospitalId?: string, hospitalName?: string, ids?: Array<string>, specialtyId?: string, consultationEnabled?: boolean, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DoctorsModel> {
            return localVarFp.apiV1DoctorsGet(hospitalId, hospitalName, ids, specialtyId, consultationEnabled, id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a Doctor.
         * @param {CreateDoctorCommand} [createDoctorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsPost(createDoctorCommand?: CreateDoctorCommand, options?: any): AxiosPromise<DoctorModel> {
            return localVarFp.apiV1DoctorsPost(createDoctorCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all Doctors.
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {Array<string>} [ids] 
         * @param {string} [specialtyId] 
         * @param {boolean} [consultationEnabled] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1DoctorsSimpleGet(hospitalId?: string, hospitalName?: string, ids?: Array<string>, specialtyId?: string, consultationEnabled?: boolean, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DoctorsSimpleModel> {
            return localVarFp.apiV1DoctorsSimpleGet(hospitalId, hospitalName, ids, specialtyId, consultationEnabled, id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1DoctorsDoctorIdCertificatesCertificateIdDelete operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdDeleteRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdDelete
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdDelete
     */
    readonly certificateId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdCertificatesCertificateIdGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdGet
     */
    readonly certificateId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdCertificatesCertificateIdPut operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdPutRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdPut
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdPut
     */
    readonly certificateId: string

    /**
     * 
     * @type {UpdateDoctorCertificateCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdPut
     */
    readonly updateDoctorCertificateCommand?: UpdateDoctorCertificateCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdCertificatesGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdCertificatesGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdCertificatesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesGet
     */
    readonly doctorName?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesGet
     */
    readonly certificateId?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesGet
     */
    readonly certificate?: string

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesGet
     */
    readonly activeFrom?: Date

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesGet
     */
    readonly activeTo?: Date

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DoctorsDoctorIdCertificatesPost operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdCertificatesPostRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdCertificatesPostRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesPost
     */
    readonly doctorId: string

    /**
     * 
     * @type {CreateDoctorCertificateCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesPost
     */
    readonly createDoctorCertificateCommand?: CreateDoctorCertificateCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdCertificatesSortPut operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdCertificatesSortPutRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdCertificatesSortPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesSortPut
     */
    readonly doctorId: string

    /**
     * 
     * @type {DoctorCertificateSortingCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdCertificatesSortPut
     */
    readonly doctorCertificateSortingCommand?: DoctorCertificateSortingCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdDelete operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdDeleteRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdDelete
     */
    readonly doctorId: string

    /**
     * 
     * @type {boolean}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1DoctorsDoctorIdEducationsEducationIdDelete operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdDeleteRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdDelete
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdDelete
     */
    readonly educationId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdEducationsEducationIdGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdGet
     */
    readonly educationId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdEducationsEducationIdPut operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdPutRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdPut
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdPut
     */
    readonly educationId: string

    /**
     * 
     * @type {UpdateDoctorEducationCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdPut
     */
    readonly updateDoctorEducationCommand?: UpdateDoctorEducationCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdEducationsGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdEducationsGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdEducationsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsGet
     */
    readonly doctorName?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsGet
     */
    readonly educationId?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsGet
     */
    readonly institution?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsGet
     */
    readonly qualification?: string

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsGet
     */
    readonly graduationDate?: Date

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DoctorsDoctorIdEducationsPost operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdEducationsPostRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdEducationsPostRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsPost
     */
    readonly doctorId: string

    /**
     * 
     * @type {CreateDoctorEducationCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsPost
     */
    readonly createDoctorEducationCommand?: CreateDoctorEducationCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdEducationsSortPut operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdEducationsSortPutRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdEducationsSortPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsSortPut
     */
    readonly doctorId: string

    /**
     * 
     * @type {DoctorEducationSortingCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdEducationsSortPut
     */
    readonly doctorEducationSortingCommand?: DoctorEducationSortingCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdGet
     */
    readonly doctorId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdLanguagesGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdLanguagesGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdLanguagesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DoctorsDoctorIdLanguagesLanguageCodeDelete operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeDeleteRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeDelete
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeDelete
     */
    readonly languageCode: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdLanguagesLanguageCodeGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeGet
     */
    readonly languageCode: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdLanguagesLanguageCodePut operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodePutRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodePutRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodePut
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodePut
     */
    readonly languageCode: string

    /**
     * 
     * @type {UpdateDoctorLanguageCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodePut
     */
    readonly updateDoctorLanguageCommand?: UpdateDoctorLanguageCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdLanguagesPost operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdLanguagesPostRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdLanguagesPostRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesPost
     */
    readonly doctorId: string

    /**
     * 
     * @type {CreateDoctorLanguageCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdLanguagesPost
     */
    readonly createDoctorLanguageCommand?: CreateDoctorLanguageCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdMediasGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdMediasGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdMediasGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasGet
     */
    readonly id?: string

    /**
     * 
     * @type {MediaType}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasGet
     */
    readonly mediaType?: MediaType

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DoctorsDoctorIdMediasMediaIdDelete operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdDeleteRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdDelete
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdDelete
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdMediasMediaIdGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdGet
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdMediasMediaIdPut operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdPutRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdPut
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdPut
     */
    readonly mediaId: string

    /**
     * 
     * @type {UpdateMediaCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdPut
     */
    readonly updateMediaCommand?: UpdateMediaCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdMediasPost operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdMediasPostRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdMediasPostRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasPost
     */
    readonly doctorId: string

    /**
     * 
     * @type {CreateMediaCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdMediasPost
     */
    readonly createMediaCommand?: CreateMediaCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdPortfoliosGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdPortfoliosGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdPortfoliosGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosGet
     */
    readonly doctorName?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosGet
     */
    readonly portfolioId?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosGet
     */
    readonly name?: string

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdDeleteRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete
     */
    readonly portfolioId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdPortfoliosPortfolioIdGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdGet
     */
    readonly portfolioId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdPortfoliosPortfolioIdPut operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdPutRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdPut
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdPut
     */
    readonly portfolioId: string

    /**
     * 
     * @type {UpdateDoctorPortfolioCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdPut
     */
    readonly updateDoctorPortfolioCommand?: UpdateDoctorPortfolioCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdPortfoliosPost operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdPortfoliosPostRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdPortfoliosPostRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosPost
     */
    readonly doctorId: string

    /**
     * 
     * @type {CreateDoctorPortfolioCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPortfoliosPost
     */
    readonly createDoctorPortfolioCommand?: CreateDoctorPortfolioCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdPut operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdPutRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPut
     */
    readonly doctorId: string

    /**
     * 
     * @type {UpdateDoctorCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdPut
     */
    readonly updateDoctorCommand?: UpdateDoctorCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdReactivatePut operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdReactivatePutRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdReactivatePut
     */
    readonly doctorId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdRevalidatePost operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdRevalidatePostRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdRevalidatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdRevalidatePost
     */
    readonly doctorId: string

    /**
     * 
     * @type {boolean}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdRevalidatePost
     */
    readonly includeCurrent?: boolean
}

/**
 * Request parameters for apiV1DoctorsDoctorIdSpecialtiesGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGet
     */
    readonly specialtyId?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGet
     */
    readonly specialtyName?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DoctorsDoctorIdSpecialtiesPost operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdSpecialtiesPostRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdSpecialtiesPostRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesPost
     */
    readonly doctorId: string

    /**
     * 
     * @type {CreateDoctorSpecialtyCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesPost
     */
    readonly createDoctorSpecialtyCommand?: CreateDoctorSpecialtyCommand
}

/**
 * Request parameters for apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDeleteRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete
     */
    readonly specialtyId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGetRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet
     */
    readonly specialtyId: string
}

/**
 * Request parameters for apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPutRequest
 */
export interface DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut
     */
    readonly doctorId: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut
     */
    readonly specialtyId: string

    /**
     * 
     * @type {UpdateDoctorSpecialtyCommand}
     * @memberof DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut
     */
    readonly updateDoctorSpecialtyCommand?: UpdateDoctorSpecialtyCommand
}

/**
 * Request parameters for apiV1DoctorsGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsGetRequest
 */
export interface DoctorsApiApiV1DoctorsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {Array<string>}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly ids?: Array<string>

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly specialtyId?: string

    /**
     * 
     * @type {boolean}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly consultationEnabled?: boolean

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly fullname?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly email?: string

    /**
     * 
     * @type {Gender}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly gender?: Gender

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly dateOfBirth?: Date

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly created?: Date

    /**
     * 
     * @type {boolean}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1DoctorsPost operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsPostRequest
 */
export interface DoctorsApiApiV1DoctorsPostRequest {
    /**
     * 
     * @type {CreateDoctorCommand}
     * @memberof DoctorsApiApiV1DoctorsPost
     */
    readonly createDoctorCommand?: CreateDoctorCommand
}

/**
 * Request parameters for apiV1DoctorsSimpleGet operation in DoctorsApi.
 * @export
 * @interface DoctorsApiApiV1DoctorsSimpleGetRequest
 */
export interface DoctorsApiApiV1DoctorsSimpleGetRequest {
    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {Array<string>}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly ids?: Array<string>

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly specialtyId?: string

    /**
     * 
     * @type {boolean}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly consultationEnabled?: boolean

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly fullname?: string

    /**
     * 
     * @type {string}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly email?: string

    /**
     * 
     * @type {Gender}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly gender?: Gender

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly dateOfBirth?: Date

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly created?: Date

    /**
     * 
     * @type {boolean}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof DoctorsApiApiV1DoctorsSimpleGet
     */
    readonly lastRetrieved?: Date
}

/**
 * DoctorsApi - object-oriented interface
 * @export
 * @class DoctorsApi
 * @extends {BaseAPI}
 */
export class DoctorsApi extends BaseAPI {
    /**
     * 
     * @summary Delete DoctorCertificate.
     * @param {DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdCertificatesCertificateIdDelete(requestParameters: DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdDeleteRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdCertificatesCertificateIdDelete(requestParameters.doctorId, requestParameters.certificateId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DoctorCertificate.
     * @param {DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdCertificatesCertificateIdGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdCertificatesCertificateIdGet(requestParameters.doctorId, requestParameters.certificateId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update DoctorCertificate.
     * @param {DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdCertificatesCertificateIdPut(requestParameters: DoctorsApiApiV1DoctorsDoctorIdCertificatesCertificateIdPutRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdCertificatesCertificateIdPut(requestParameters.doctorId, requestParameters.certificateId, requestParameters.updateDoctorCertificateCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete DoctorCertificate.
     * @param {DoctorsApiApiV1DoctorsDoctorIdCertificatesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdCertificatesGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdCertificatesGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdCertificatesGet(requestParameters.doctorId, requestParameters.doctorName, requestParameters.certificateId, requestParameters.certificate, requestParameters.activeFrom, requestParameters.activeTo, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create DoctorCertificate.
     * @param {DoctorsApiApiV1DoctorsDoctorIdCertificatesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdCertificatesPost(requestParameters: DoctorsApiApiV1DoctorsDoctorIdCertificatesPostRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdCertificatesPost(requestParameters.doctorId, requestParameters.createDoctorCertificateCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Batch for doctor certificates sorting
     * @param {DoctorsApiApiV1DoctorsDoctorIdCertificatesSortPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdCertificatesSortPut(requestParameters: DoctorsApiApiV1DoctorsDoctorIdCertificatesSortPutRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdCertificatesSortPut(requestParameters.doctorId, requestParameters.doctorCertificateSortingCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Doctor.
     * @param {DoctorsApiApiV1DoctorsDoctorIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdDelete(requestParameters: DoctorsApiApiV1DoctorsDoctorIdDeleteRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdDelete(requestParameters.doctorId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete DoctorEducation
     * @param {DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdEducationsEducationIdDelete(requestParameters: DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdDeleteRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdEducationsEducationIdDelete(requestParameters.doctorId, requestParameters.educationId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DoctorEducation.
     * @param {DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdEducationsEducationIdGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdEducationsEducationIdGet(requestParameters.doctorId, requestParameters.educationId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update DoctorEducation.
     * @param {DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdEducationsEducationIdPut(requestParameters: DoctorsApiApiV1DoctorsDoctorIdEducationsEducationIdPutRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdEducationsEducationIdPut(requestParameters.doctorId, requestParameters.educationId, requestParameters.updateDoctorEducationCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all DoctorEducations.
     * @param {DoctorsApiApiV1DoctorsDoctorIdEducationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdEducationsGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdEducationsGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdEducationsGet(requestParameters.doctorId, requestParameters.doctorName, requestParameters.educationId, requestParameters.institution, requestParameters.qualification, requestParameters.graduationDate, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create DoctorEducation.
     * @param {DoctorsApiApiV1DoctorsDoctorIdEducationsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdEducationsPost(requestParameters: DoctorsApiApiV1DoctorsDoctorIdEducationsPostRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdEducationsPost(requestParameters.doctorId, requestParameters.createDoctorEducationCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Batch for doctor educations sorting
     * @param {DoctorsApiApiV1DoctorsDoctorIdEducationsSortPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdEducationsSortPut(requestParameters: DoctorsApiApiV1DoctorsDoctorIdEducationsSortPutRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdEducationsSortPut(requestParameters.doctorId, requestParameters.doctorEducationSortingCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get doctor
     * @param {DoctorsApiApiV1DoctorsDoctorIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdGet(requestParameters.doctorId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all DoctorLanguages.
     * @param {DoctorsApiApiV1DoctorsDoctorIdLanguagesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdLanguagesGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdLanguagesGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdLanguagesGet(requestParameters.doctorId, requestParameters.languageCode, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete DoctorLanguage
     * @param {DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdLanguagesLanguageCodeDelete(requestParameters: DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeDeleteRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdLanguagesLanguageCodeDelete(requestParameters.doctorId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DoctorLanguage.
     * @param {DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdLanguagesLanguageCodeGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodeGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdLanguagesLanguageCodeGet(requestParameters.doctorId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update DoctorLanguage.
     * @param {DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdLanguagesLanguageCodePut(requestParameters: DoctorsApiApiV1DoctorsDoctorIdLanguagesLanguageCodePutRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdLanguagesLanguageCodePut(requestParameters.doctorId, requestParameters.languageCode, requestParameters.updateDoctorLanguageCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create DoctorLanguage.
     * @param {DoctorsApiApiV1DoctorsDoctorIdLanguagesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdLanguagesPost(requestParameters: DoctorsApiApiV1DoctorsDoctorIdLanguagesPostRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdLanguagesPost(requestParameters.doctorId, requestParameters.createDoctorLanguageCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all DoctorMedias.
     * @param {DoctorsApiApiV1DoctorsDoctorIdMediasGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdMediasGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdMediasGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdMediasGet(requestParameters.doctorId, requestParameters.id, requestParameters.mediaType, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete DoctorMedia
     * @param {DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdMediasMediaIdDelete(requestParameters: DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdDeleteRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdMediasMediaIdDelete(requestParameters.doctorId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DoctorMedia.
     * @param {DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdMediasMediaIdGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdMediasMediaIdGet(requestParameters.doctorId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update DoctorMedia.
     * @param {DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdMediasMediaIdPut(requestParameters: DoctorsApiApiV1DoctorsDoctorIdMediasMediaIdPutRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdMediasMediaIdPut(requestParameters.doctorId, requestParameters.mediaId, requestParameters.updateMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create DoctorMedia.
     * @param {DoctorsApiApiV1DoctorsDoctorIdMediasPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdMediasPost(requestParameters: DoctorsApiApiV1DoctorsDoctorIdMediasPostRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdMediasPost(requestParameters.doctorId, requestParameters.createMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get All DoctorPortfolios
     * @param {DoctorsApiApiV1DoctorsDoctorIdPortfoliosGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdPortfoliosGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdPortfoliosGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdPortfoliosGet(requestParameters.doctorId, requestParameters.doctorName, requestParameters.portfolioId, requestParameters.name, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete DoctorPortfolio.
     * @param {DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete(requestParameters: DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdDeleteRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdPortfoliosPortfolioIdDelete(requestParameters.doctorId, requestParameters.portfolioId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DoctorPortfolio.
     * @param {DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdPortfoliosPortfolioIdGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdPortfoliosPortfolioIdGet(requestParameters.doctorId, requestParameters.portfolioId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update DoctorPortfolio.
     * @param {DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdPortfoliosPortfolioIdPut(requestParameters: DoctorsApiApiV1DoctorsDoctorIdPortfoliosPortfolioIdPutRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdPortfoliosPortfolioIdPut(requestParameters.doctorId, requestParameters.portfolioId, requestParameters.updateDoctorPortfolioCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create DoctorPortfolio.
     * @param {DoctorsApiApiV1DoctorsDoctorIdPortfoliosPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdPortfoliosPost(requestParameters: DoctorsApiApiV1DoctorsDoctorIdPortfoliosPostRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdPortfoliosPost(requestParameters.doctorId, requestParameters.createDoctorPortfolioCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Doctor.
     * @param {DoctorsApiApiV1DoctorsDoctorIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdPut(requestParameters: DoctorsApiApiV1DoctorsDoctorIdPutRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdPut(requestParameters.doctorId, requestParameters.updateDoctorCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Doctor.
     * @param {DoctorsApiApiV1DoctorsDoctorIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdReactivatePut(requestParameters: DoctorsApiApiV1DoctorsDoctorIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdReactivatePut(requestParameters.doctorId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revalidate doctor
     * @param {DoctorsApiApiV1DoctorsDoctorIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdRevalidatePost(requestParameters: DoctorsApiApiV1DoctorsDoctorIdRevalidatePostRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdRevalidatePost(requestParameters.doctorId, requestParameters.includeCurrent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get All DoctorSpecialties.
     * @param {DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdSpecialtiesGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdSpecialtiesGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdSpecialtiesGet(requestParameters.doctorId, requestParameters.specialtyId, requestParameters.specialtyName, requestParameters.languageCode, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Link a doctor to a specialty.
     * @param {DoctorsApiApiV1DoctorsDoctorIdSpecialtiesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdSpecialtiesPost(requestParameters: DoctorsApiApiV1DoctorsDoctorIdSpecialtiesPostRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdSpecialtiesPost(requestParameters.doctorId, requestParameters.createDoctorSpecialtyCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Remove link between the doctor and the specialty.
     * @param {DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete(requestParameters: DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDeleteRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdDelete(requestParameters.doctorId, requestParameters.specialtyId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get DoctorSpecialty
     * @param {DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet(requestParameters: DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGetRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdGet(requestParameters.doctorId, requestParameters.specialtyId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update DoctorSpecialty.
     * @param {DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut(requestParameters: DoctorsApiApiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPutRequest, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsDoctorIdSpecialtiesSpecialtyIdPut(requestParameters.doctorId, requestParameters.specialtyId, requestParameters.updateDoctorSpecialtyCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all Doctors.
     * @param {DoctorsApiApiV1DoctorsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsGet(requestParameters: DoctorsApiApiV1DoctorsGetRequest = {}, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsGet(requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.ids, requestParameters.specialtyId, requestParameters.consultationEnabled, requestParameters.id, requestParameters.fullname, requestParameters.email, requestParameters.gender, requestParameters.dateOfBirth, requestParameters.created, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a Doctor.
     * @param {DoctorsApiApiV1DoctorsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsPost(requestParameters: DoctorsApiApiV1DoctorsPostRequest = {}, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsPost(requestParameters.createDoctorCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all Doctors.
     * @param {DoctorsApiApiV1DoctorsSimpleGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DoctorsApi
     */
    public apiV1DoctorsSimpleGet(requestParameters: DoctorsApiApiV1DoctorsSimpleGetRequest = {}, options?: AxiosRequestConfig) {
        return DoctorsApiFp(this.configuration).apiV1DoctorsSimpleGet(requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.ids, requestParameters.specialtyId, requestParameters.consultationEnabled, requestParameters.id, requestParameters.fullname, requestParameters.email, requestParameters.gender, requestParameters.dateOfBirth, requestParameters.created, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }
}
